﻿using UnityEngine;
using System.Collections;

public class AtmosphereParticleColoring : AtmosphereColorEnforcer
{
	[Range (0, 1)]
	public float alphaOverWrite;

	public override void UpdateColorSettings ()
	{
		base.UpdateColorSettings ();
		resultColor.a = alphaOverWrite;
		myParticleSystem.startColor = resultColor;
	}



	private ParticleSystem _myParticleSystem;

	private ParticleSystem myParticleSystem {
		get {
			if (_myParticleSystem == null)
				_myParticleSystem = GetComponent<ParticleSystem> ();
			return _myParticleSystem;
		}   
		set {
			_myParticleSystem = value;
		}
	}





}
