// Upgrade NOTE: replaced '_Object2World' with 'unity_ObjectToWorld'

// Shader created with Shader Forge v1.28 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.28;sub:START;pass:START;ps:flbk:,iptp:0,cusa:False,bamd:0,lico:1,lgpr:1,limd:1,spmd:0,trmd:0,grmd:0,uamb:False,mssp:True,bkdf:True,hqlp:True,rprd:True,enco:True,rmgx:True,rpth:0,vtps:0,hqsc:True,nrmq:1,nrsp:0,vomd:0,spxs:False,tesm:0,olmd:1,culm:0,bsrc:3,bdst:7,dpts:2,wrdp:False,dith:0,rfrpo:False,rfrpn:Refraction,coma:15,ufog:True,aust:False,igpj:True,qofs:0,qpre:3,rntp:2,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.6252162,fgcg:0.7272044,fgcb:0.8676471,fgca:1,fgde:0.003,fgrn:0,fgrf:300,stcl:False,stva:128,stmr:255,stmw:255,stcp:6,stps:0,stfa:0,stfz:0,ofsf:0,ofsu:0,f2p0:True,fnsp:False,fnfb:False;n:type:ShaderForge.SFN_Final,id:396,x:33421,y:32676,varname:node_396,prsc:2|diff-1571-OUT,emission-3302-OUT,transm-7576-OUT,lwrap-8046-OUT,alpha-2533-OUT;n:type:ShaderForge.SFN_DepthBlend,id:562,x:31906,y:33308,varname:node_562,prsc:2|DIST-2296-OUT;n:type:ShaderForge.SFN_Slider,id:4526,x:31473,y:33121,ptovrint:False,ptlb:Sea Opacity,ptin:_SeaOpacity,varname:_Opacityofftheocean,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.95,max:1;n:type:ShaderForge.SFN_Slider,id:1185,x:33353,y:32489,ptovrint:False,ptlb:Specular,ptin:_Specular,varname:_Specular,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.1,max:0.9;n:type:ShaderForge.SFN_Slider,id:5085,x:33353,y:32386,ptovrint:False,ptlb:Gloss,ptin:_Gloss,varname:_Gloss,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.7,max:1;n:type:ShaderForge.SFN_Multiply,id:2533,x:31896,y:33121,varname:node_2533,prsc:2|A-4526-OUT,B-562-OUT;n:type:ShaderForge.SFN_Slider,id:2296,x:31473,y:33307,ptovrint:False,ptlb:Sea Edge Width,ptin:_SeaEdgeWidth,varname:node_2296,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:15;n:type:ShaderForge.SFN_Tex2d,id:6849,x:31614,y:32687,ptovrint:False,ptlb:Sea Edge Foam,ptin:_SeaEdgeFoam,varname:node_6849,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False|UVIN-4878-UVOUT;n:type:ShaderForge.SFN_Slider,id:1983,x:31287,y:32940,ptovrint:False,ptlb:Sea Edge Depth,ptin:_SeaEdgeDepth,varname:node_1983,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:20;n:type:ShaderForge.SFN_DepthBlend,id:2989,x:31697,y:32860,varname:node_2989,prsc:2|DIST-1983-OUT;n:type:ShaderForge.SFN_RemapRange,id:7206,x:31896,y:32860,varname:node_7206,prsc:2,frmn:0,frmx:1,tomn:1,tomx:0|IN-2989-OUT;n:type:ShaderForge.SFN_Multiply,id:3891,x:32111,y:32812,varname:node_3891,prsc:2|A-6849-RGB,B-7206-OUT,C-8447-RGB;n:type:ShaderForge.SFN_Color,id:7080,x:31761,y:31469,ptovrint:False,ptlb:Sea Color Edge,ptin:_SeaColorEdge,varname:node_7080,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:1,c2:1,c3:1,c4:1;n:type:ShaderForge.SFN_Tex2d,id:3466,x:31992,y:31862,ptovrint:False,ptlb:Sea Texture,ptin:_SeaTexture,varname:node_3466,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False|UVIN-4878-UVOUT;n:type:ShaderForge.SFN_Multiply,id:6809,x:32477,y:31742,varname:node_6809,prsc:2|A-8251-OUT,B-3466-RGB;n:type:ShaderForge.SFN_Multiply,id:3302,x:32971,y:32783,varname:node_3302,prsc:2|A-1571-OUT,B-1866-OUT;n:type:ShaderForge.SFN_Slider,id:1866,x:32848,y:33207,ptovrint:False,ptlb:Emision Amount,ptin:_EmisionAmount,varname:node_1866,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:7576,x:33353,y:32250,ptovrint:False,ptlb:Transmission,ptin:_Transmission,varname:node_7576,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:8046,x:33353,y:32143,ptovrint:False,ptlb:LightWrapper,ptin:_LightWrapper,varname:node_8046,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Color,id:7839,x:31992,y:31652,ptovrint:False,ptlb:Sea Color Depth,ptin:_SeaColorDepth,varname:node_7839,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_Lerp,id:1526,x:32257,y:31521,varname:node_1526,prsc:2|A-7080-RGB,B-7839-RGB,T-1773-OUT;n:type:ShaderForge.SFN_DepthBlend,id:1773,x:31761,y:31628,varname:node_1773,prsc:2|DIST-7694-OUT;n:type:ShaderForge.SFN_Slider,id:7694,x:31425,y:31553,ptovrint:False,ptlb:Sea Depth Color,ptin:_SeaDepthColor,varname:node_7694,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:50;n:type:ShaderForge.SFN_Lerp,id:8210,x:32547,y:32668,varname:node_8210,prsc:2|A-6809-OUT,B-5391-OUT,T-7206-OUT;n:type:ShaderForge.SFN_Relay,id:1571,x:32849,y:32650,varname:node_1571,prsc:2|IN-8210-OUT;n:type:ShaderForge.SFN_Color,id:5031,x:32238,y:31108,ptovrint:False,ptlb:Sea Side Color,ptin:_SeaSideColor,varname:node_5031,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_ComponentMask,id:7913,x:31854,y:30995,varname:node_7913,prsc:2,cc1:1,cc2:-1,cc3:-1,cc4:-1|IN-4492-OUT;n:type:ShaderForge.SFN_Lerp,id:8251,x:32443,y:31341,varname:node_8251,prsc:2|A-5031-RGB,B-1526-OUT,T-808-OUT;n:type:ShaderForge.SFN_NormalVector,id:4492,x:31664,y:30995,prsc:2,pt:False;n:type:ShaderForge.SFN_Slider,id:1171,x:31684,y:31183,ptovrint:False,ptlb:Side Divide,ptin:_SideDivide,varname:node_1171,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:1,max:10;n:type:ShaderForge.SFN_Divide,id:8884,x:32065,y:31201,varname:node_8884,prsc:2|A-7913-OUT,B-1171-OUT;n:type:ShaderForge.SFN_Slider,id:7197,x:31210,y:31230,ptovrint:False,ptlb:Side Height,ptin:_SideHeight,varname:node_7197,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-10,cur:0,max:10;n:type:ShaderForge.SFN_Subtract,id:7757,x:32007,y:31341,varname:node_7757,prsc:2|A-8884-OUT,B-7197-OUT;n:type:ShaderForge.SFN_Clamp01,id:808,x:32184,y:31379,varname:node_808,prsc:2|IN-7757-OUT;n:type:ShaderForge.SFN_Slider,id:2312,x:30457,y:32019,ptovrint:False,ptlb:Sea Text panning X,ptin:_SeaTextpanningX,varname:node_2312,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-1,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:7445,x:30846,y:32020,ptovrint:False,ptlb:Sea Text panning Y,ptin:_SeaTextpanningY,varname:node_7445,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-1,cur:0,max:1;n:type:ShaderForge.SFN_TexCoord,id:9576,x:30521,y:31610,varname:node_9576,prsc:2,uv:0;n:type:ShaderForge.SFN_Panner,id:2496,x:30862,y:31634,varname:node_2496,prsc:2,spu:0,spv:1|UVIN-9576-UVOUT,DIST-3840-OUT;n:type:ShaderForge.SFN_Panner,id:4878,x:31191,y:31639,varname:node_4878,prsc:2,spu:1,spv:0|UVIN-2496-UVOUT,DIST-7653-OUT;n:type:ShaderForge.SFN_Time,id:392,x:30145,y:31807,varname:node_392,prsc:2;n:type:ShaderForge.SFN_Multiply,id:3840,x:30597,y:31854,varname:node_3840,prsc:2|A-392-TSL,B-2312-OUT;n:type:ShaderForge.SFN_Multiply,id:7653,x:31111,y:31854,varname:node_7653,prsc:2|A-392-TSL,B-7445-OUT;n:type:ShaderForge.SFN_Color,id:8447,x:31664,y:32397,ptovrint:False,ptlb:Sea Edge Foam Color,ptin:_SeaEdgeFoamColor,varname:node_8447,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_Multiply,id:5391,x:32132,y:32593,varname:node_5391,prsc:2|A-8447-RGB,B-6849-RGB;proporder:1185-5085-1866-4526-7080-7839-7694-3466-2296-1983-8447-6849-7576-8046-5031-1171-7197-2312-7445;pass:END;sub:END;*/

Shader "Another Circus/Water River" {
    Properties {
        _Specular ("Specular", Range(0, 0.9)) = 0.1
        _Gloss ("Gloss", Range(0, 1)) = 0.7
        _EmisionAmount ("Emision Amount", Range(0, 1)) = 0
        _SeaOpacity ("Sea Opacity", Range(0, 1)) = 0.95
        _SeaColorEdge ("Sea Color Edge", Color) = (1,1,1,1)
        _SeaColorDepth ("Sea Color Depth", Color) = (0.5,0.5,0.5,1)
        _SeaDepthColor ("Sea Depth Color", Range(0, 50)) = 0
        _SeaTexture ("Sea Texture", 2D) = "white" {}
        _SeaEdgeWidth ("Sea Edge Width", Range(0, 15)) = 0
        _SeaEdgeDepth ("Sea Edge Depth", Range(0, 20)) = 0
        _SeaEdgeFoamColor ("Sea Edge Foam Color", Color) = (0.5,0.5,0.5,1)
        _SeaEdgeFoam ("Sea Edge Foam", 2D) = "white" {}
        _Transmission ("Transmission", Range(0, 1)) = 0
        _LightWrapper ("LightWrapper", Range(0, 1)) = 0
        _SeaSideColor ("Sea Side Color", Color) = (0,0.5,0.5,1)
        _SideDivide ("Side Divide", Range(0, 10)) = 1
        _SideHeight ("Side Height", Range(-10, 10)) = 0
        _SeaTextpanningX ("Sea Text panning X", Range(-1, 1)) = 0
        _SeaTextpanningY ("Sea Text panning Y", Range(-1, 1)) = 0
        [HideInInspector]_Cutoff ("Alpha cutoff", Range(0,1)) = 0.5
    }
    SubShader {
        Tags {
            "IgnoreProjector"="True"
            "Queue"="Transparent"
            "RenderType"="Transparent"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            Blend SrcAlpha OneMinusSrcAlpha
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #define SHOULD_SAMPLE_SH ( defined (LIGHTMAP_OFF) && defined(DYNAMICLIGHTMAP_OFF) )
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "Lighting.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma multi_compile_fwdbase
            #pragma multi_compile LIGHTMAP_OFF LIGHTMAP_ON
            #pragma multi_compile DIRLIGHTMAP_OFF DIRLIGHTMAP_COMBINED DIRLIGHTMAP_SEPARATE
            #pragma multi_compile DYNAMICLIGHTMAP_OFF DYNAMICLIGHTMAP_ON
            #pragma multi_compile_fog
            #pragma exclude_renderers xbox360 xboxone ps3 ps4 psp2 
            #pragma target 2.0
            uniform sampler2D_float _CameraDepthTexture;
            uniform float4 _TimeEditor;
            uniform float _SeaOpacity;
            uniform float _SeaEdgeWidth;
            uniform sampler2D _SeaEdgeFoam; uniform float4 _SeaEdgeFoam_ST;
            uniform float _SeaEdgeDepth;
            uniform float4 _SeaColorEdge;
            uniform sampler2D _SeaTexture; uniform float4 _SeaTexture_ST;
            uniform float _EmisionAmount;
            uniform float _Transmission;
            uniform float _LightWrapper;
            uniform float4 _SeaColorDepth;
            uniform float _SeaDepthColor;
            uniform float4 _SeaSideColor;
            uniform float _SideDivide;
            uniform float _SideHeight;
            uniform float _SeaTextpanningX;
            uniform float _SeaTextpanningY;
            uniform float4 _SeaEdgeFoamColor;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float4 tangent : TANGENT;
                float2 texcoord0 : TEXCOORD0;
                float2 texcoord1 : TEXCOORD1;
                float2 texcoord2 : TEXCOORD2;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float2 uv1 : TEXCOORD1;
                float2 uv2 : TEXCOORD2;
                float4 posWorld : TEXCOORD3;
                float3 normalDir : TEXCOORD4;
                float3 tangentDir : TEXCOORD5;
                float3 bitangentDir : TEXCOORD6;
                float4 projPos : TEXCOORD7;
                UNITY_FOG_COORDS(8)
                #if defined(LIGHTMAP_ON) || defined(UNITY_SHOULD_SAMPLE_SH)
                    float4 ambientOrLightmapUV : TEXCOORD9;
                #endif
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.uv1 = v.texcoord1;
                o.uv2 = v.texcoord2;
                #ifdef LIGHTMAP_ON
                    o.ambientOrLightmapUV.xy = v.texcoord1.xy * unity_LightmapST.xy + unity_LightmapST.zw;
                    o.ambientOrLightmapUV.zw = 0;
                #endif
                #ifdef DYNAMICLIGHTMAP_ON
                    o.ambientOrLightmapUV.zw = v.texcoord2.xy * unity_DynamicLightmapST.xy + unity_DynamicLightmapST.zw;
                #endif
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.tangentDir = normalize( mul( unity_ObjectToWorld, float4( v.tangent.xyz, 0.0 ) ).xyz );
                o.bitangentDir = normalize(cross(o.normalDir, o.tangentDir) * v.tangent.w);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                o.projPos = ComputeScreenPos (o.pos);
                COMPUTE_EYEDEPTH(o.projPos.z);
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3x3 tangentTransform = float3x3( i.tangentDir, i.bitangentDir, i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float3 viewReflectDirection = reflect( -viewDirection, normalDirection );
                float sceneZ = max(0,LinearEyeDepth (UNITY_SAMPLE_DEPTH(tex2Dproj(_CameraDepthTexture, UNITY_PROJ_COORD(i.projPos)))) - _ProjectionParams.g);
                float partZ = max(0,i.projPos.z - _ProjectionParams.g);
                float3 lightDirection = normalize(_WorldSpaceLightPos0.xyz);
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
                float attenuation = 1;
                float3 attenColor = attenuation * _LightColor0.xyz;
                float Pi = 3.141592654;
                float InvPi = 0.31830988618;
/////// GI Data:
                UnityLight light;
                #ifdef LIGHTMAP_OFF
                    light.color = lightColor;
                    light.dir = lightDirection;
                    light.ndotl = LambertTerm (normalDirection, light.dir);
                #else
                    light.color = half3(0.f, 0.f, 0.f);
                    light.ndotl = 0.0f;
                    light.dir = half3(0.f, 0.f, 0.f);
                #endif
                UnityGIInput d;
                d.light = light;
                d.worldPos = i.posWorld.xyz;
                d.worldViewDir = viewDirection;
                d.atten = attenuation;
                #if defined(LIGHTMAP_ON) || defined(DYNAMICLIGHTMAP_ON)
                    d.ambient = 0;
                    d.lightmapUV = i.ambientOrLightmapUV;
                #else
                    d.ambient = i.ambientOrLightmapUV;
                #endif
                Unity_GlossyEnvironmentData ugls_en_data;
                ugls_en_data.roughness = 1.0 - 0;
                ugls_en_data.reflUVW = viewReflectDirection;
                UnityGI gi = UnityGlobalIllumination(d, 1, normalDirection, ugls_en_data );
                lightDirection = gi.light.dir;
                lightColor = gi.light.color;
/////// Diffuse:
                float NdotL = dot( normalDirection, lightDirection );
                float3 w = float3(_LightWrapper,_LightWrapper,_LightWrapper)*0.5; // Light wrapping
                float3 NdotLWrap = NdotL * ( 1.0 - w );
                float3 forwardLight = max(float3(0.0,0.0,0.0), NdotLWrap + w );
                float3 backLight = max(float3(0.0,0.0,0.0), -NdotLWrap + w ) * float3(_Transmission,_Transmission,_Transmission);
                NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = (forwardLight+backLight)*(0.5-max(w.r,max(w.g,w.b))*0.5) * attenColor;
                float3 indirectDiffuse = float3(0,0,0);
                indirectDiffuse += gi.indirect.diffuse;
                float4 node_392 = _Time + _TimeEditor;
                float2 node_4878 = ((i.uv0+(node_392.r*_SeaTextpanningX)*float2(0,1))+(node_392.r*_SeaTextpanningY)*float2(1,0));
                float4 _SeaTexture_var = tex2D(_SeaTexture,TRANSFORM_TEX(node_4878, _SeaTexture));
                float4 _SeaEdgeFoam_var = tex2D(_SeaEdgeFoam,TRANSFORM_TEX(node_4878, _SeaEdgeFoam));
                float node_7206 = (saturate((sceneZ-partZ)/_SeaEdgeDepth)*-1.0+1.0);
                float3 node_1571 = lerp((lerp(_SeaSideColor.rgb,lerp(_SeaColorEdge.rgb,_SeaColorDepth.rgb,saturate((sceneZ-partZ)/_SeaDepthColor)),saturate(((i.normalDir.g/_SideDivide)-_SideHeight)))*_SeaTexture_var.rgb),(_SeaEdgeFoamColor.rgb*_SeaEdgeFoam_var.rgb),node_7206);
                float3 diffuseColor = node_1571;
                float3 diffuse = (directDiffuse + indirectDiffuse) * diffuseColor;
////// Emissive:
                float3 emissive = (node_1571*_EmisionAmount);
/// Final Color:
                float3 finalColor = diffuse + emissive;
                fixed4 finalRGBA = fixed4(finalColor,(_SeaOpacity*saturate((sceneZ-partZ)/_SeaEdgeWidth)));
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "FORWARD_DELTA"
            Tags {
                "LightMode"="ForwardAdd"
            }
            Blend One One
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDADD
            #define SHOULD_SAMPLE_SH ( defined (LIGHTMAP_OFF) && defined(DYNAMICLIGHTMAP_OFF) )
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #include "Lighting.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma multi_compile_fwdadd
            #pragma multi_compile LIGHTMAP_OFF LIGHTMAP_ON
            #pragma multi_compile DIRLIGHTMAP_OFF DIRLIGHTMAP_COMBINED DIRLIGHTMAP_SEPARATE
            #pragma multi_compile DYNAMICLIGHTMAP_OFF DYNAMICLIGHTMAP_ON
            #pragma multi_compile_fog
            #pragma exclude_renderers xbox360 xboxone ps3 ps4 psp2 
            #pragma target 2.0
            uniform sampler2D_float _CameraDepthTexture;
            uniform float4 _TimeEditor;
            uniform float _SeaOpacity;
            uniform float _SeaEdgeWidth;
            uniform sampler2D _SeaEdgeFoam; uniform float4 _SeaEdgeFoam_ST;
            uniform float _SeaEdgeDepth;
            uniform float4 _SeaColorEdge;
            uniform sampler2D _SeaTexture; uniform float4 _SeaTexture_ST;
            uniform float _EmisionAmount;
            uniform float _Transmission;
            uniform float _LightWrapper;
            uniform float4 _SeaColorDepth;
            uniform float _SeaDepthColor;
            uniform float4 _SeaSideColor;
            uniform float _SideDivide;
            uniform float _SideHeight;
            uniform float _SeaTextpanningX;
            uniform float _SeaTextpanningY;
            uniform float4 _SeaEdgeFoamColor;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float4 tangent : TANGENT;
                float2 texcoord0 : TEXCOORD0;
                float2 texcoord1 : TEXCOORD1;
                float2 texcoord2 : TEXCOORD2;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float2 uv1 : TEXCOORD1;
                float2 uv2 : TEXCOORD2;
                float4 posWorld : TEXCOORD3;
                float3 normalDir : TEXCOORD4;
                float3 tangentDir : TEXCOORD5;
                float3 bitangentDir : TEXCOORD6;
                float4 projPos : TEXCOORD7;
                LIGHTING_COORDS(8,9)
                UNITY_FOG_COORDS(10)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.uv1 = v.texcoord1;
                o.uv2 = v.texcoord2;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.tangentDir = normalize( mul( unity_ObjectToWorld, float4( v.tangent.xyz, 0.0 ) ).xyz );
                o.bitangentDir = normalize(cross(o.normalDir, o.tangentDir) * v.tangent.w);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                o.projPos = ComputeScreenPos (o.pos);
                COMPUTE_EYEDEPTH(o.projPos.z);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3x3 tangentTransform = float3x3( i.tangentDir, i.bitangentDir, i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float sceneZ = max(0,LinearEyeDepth (UNITY_SAMPLE_DEPTH(tex2Dproj(_CameraDepthTexture, UNITY_PROJ_COORD(i.projPos)))) - _ProjectionParams.g);
                float partZ = max(0,i.projPos.z - _ProjectionParams.g);
                float3 lightDirection = normalize(lerp(_WorldSpaceLightPos0.xyz, _WorldSpaceLightPos0.xyz - i.posWorld.xyz,_WorldSpaceLightPos0.w));
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
                float Pi = 3.141592654;
                float InvPi = 0.31830988618;
/////// Diffuse:
                float NdotL = dot( normalDirection, lightDirection );
                float3 w = float3(_LightWrapper,_LightWrapper,_LightWrapper)*0.5; // Light wrapping
                float3 NdotLWrap = NdotL * ( 1.0 - w );
                float3 forwardLight = max(float3(0.0,0.0,0.0), NdotLWrap + w );
                float3 backLight = max(float3(0.0,0.0,0.0), -NdotLWrap + w ) * float3(_Transmission,_Transmission,_Transmission);
                NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = (forwardLight+backLight)*(0.5-max(w.r,max(w.g,w.b))*0.5) * attenColor;
                float4 node_392 = _Time + _TimeEditor;
                float2 node_4878 = ((i.uv0+(node_392.r*_SeaTextpanningX)*float2(0,1))+(node_392.r*_SeaTextpanningY)*float2(1,0));
                float4 _SeaTexture_var = tex2D(_SeaTexture,TRANSFORM_TEX(node_4878, _SeaTexture));
                float4 _SeaEdgeFoam_var = tex2D(_SeaEdgeFoam,TRANSFORM_TEX(node_4878, _SeaEdgeFoam));
                float node_7206 = (saturate((sceneZ-partZ)/_SeaEdgeDepth)*-1.0+1.0);
                float3 node_1571 = lerp((lerp(_SeaSideColor.rgb,lerp(_SeaColorEdge.rgb,_SeaColorDepth.rgb,saturate((sceneZ-partZ)/_SeaDepthColor)),saturate(((i.normalDir.g/_SideDivide)-_SideHeight)))*_SeaTexture_var.rgb),(_SeaEdgeFoamColor.rgb*_SeaEdgeFoam_var.rgb),node_7206);
                float3 diffuseColor = node_1571;
                float3 diffuse = directDiffuse * diffuseColor;
/// Final Color:
                float3 finalColor = diffuse;
                fixed4 finalRGBA = fixed4(finalColor * (_SeaOpacity*saturate((sceneZ-partZ)/_SeaEdgeWidth)),0);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "Meta"
            Tags {
                "LightMode"="Meta"
            }
            Cull Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_META 1
            #define SHOULD_SAMPLE_SH ( defined (LIGHTMAP_OFF) && defined(DYNAMICLIGHTMAP_OFF) )
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "Lighting.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #include "UnityMetaPass.cginc"
            #pragma fragmentoption ARB_precision_hint_fastest
            #pragma multi_compile_shadowcaster
            #pragma multi_compile LIGHTMAP_OFF LIGHTMAP_ON
            #pragma multi_compile DIRLIGHTMAP_OFF DIRLIGHTMAP_COMBINED DIRLIGHTMAP_SEPARATE
            #pragma multi_compile DYNAMICLIGHTMAP_OFF DYNAMICLIGHTMAP_ON
            #pragma multi_compile_fog
            #pragma exclude_renderers xbox360 xboxone ps3 ps4 psp2 
            #pragma target 2.0
            uniform sampler2D_float _CameraDepthTexture;
            uniform float4 _TimeEditor;
            uniform sampler2D _SeaEdgeFoam; uniform float4 _SeaEdgeFoam_ST;
            uniform float _SeaEdgeDepth;
            uniform float4 _SeaColorEdge;
            uniform sampler2D _SeaTexture; uniform float4 _SeaTexture_ST;
            uniform float _EmisionAmount;
            uniform float4 _SeaColorDepth;
            uniform float _SeaDepthColor;
            uniform float4 _SeaSideColor;
            uniform float _SideDivide;
            uniform float _SideHeight;
            uniform float _SeaTextpanningX;
            uniform float _SeaTextpanningY;
            uniform float4 _SeaEdgeFoamColor;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
                float2 texcoord1 : TEXCOORD1;
                float2 texcoord2 : TEXCOORD2;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float2 uv1 : TEXCOORD1;
                float2 uv2 : TEXCOORD2;
                float4 posWorld : TEXCOORD3;
                float3 normalDir : TEXCOORD4;
                float4 projPos : TEXCOORD5;
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.uv1 = v.texcoord1;
                o.uv2 = v.texcoord2;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                o.pos = UnityMetaVertexPosition(v.vertex, v.texcoord1.xy, v.texcoord2.xy, unity_LightmapST, unity_DynamicLightmapST );
                o.projPos = ComputeScreenPos (o.pos);
                COMPUTE_EYEDEPTH(o.projPos.z);
                return o;
            }
            float4 frag(VertexOutput i) : SV_Target {
                i.normalDir = normalize(i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float sceneZ = max(0,LinearEyeDepth (UNITY_SAMPLE_DEPTH(tex2Dproj(_CameraDepthTexture, UNITY_PROJ_COORD(i.projPos)))) - _ProjectionParams.g);
                float partZ = max(0,i.projPos.z - _ProjectionParams.g);
                UnityMetaInput o;
                UNITY_INITIALIZE_OUTPUT( UnityMetaInput, o );
                
                float4 node_392 = _Time + _TimeEditor;
                float2 node_4878 = ((i.uv0+(node_392.r*_SeaTextpanningX)*float2(0,1))+(node_392.r*_SeaTextpanningY)*float2(1,0));
                float4 _SeaTexture_var = tex2D(_SeaTexture,TRANSFORM_TEX(node_4878, _SeaTexture));
                float4 _SeaEdgeFoam_var = tex2D(_SeaEdgeFoam,TRANSFORM_TEX(node_4878, _SeaEdgeFoam));
                float node_7206 = (saturate((sceneZ-partZ)/_SeaEdgeDepth)*-1.0+1.0);
                float3 node_1571 = lerp((lerp(_SeaSideColor.rgb,lerp(_SeaColorEdge.rgb,_SeaColorDepth.rgb,saturate((sceneZ-partZ)/_SeaDepthColor)),saturate(((i.normalDir.g/_SideDivide)-_SideHeight)))*_SeaTexture_var.rgb),(_SeaEdgeFoamColor.rgb*_SeaEdgeFoam_var.rgb),node_7206);
                o.Emission = (node_1571*_EmisionAmount);
                
                float3 diffColor = node_1571;
                o.Albedo = diffColor;
                
                return UnityMetaFragment( o );
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
    CustomEditor "ShaderForgeMaterialInspector"
}
