﻿using UnityEngine;
using UnityEngine.UI;
using AudioSystem;
using System.Collections;
using System.Collections.Generic;

/// <summary>
/// Text mesh loader is a class that can be added to any text mesh to replace its text contents with a text fromt the text library
/// </summary>
public class TextMeshLoader : MonoBehaviour
{
	public void OnEnable ()
	{
		EnableObjective ();
	}

	public void EnableObjective ()
	{		
		Text textMeshItem = GetComponent<Text> ();
		textMeshItem.text = TextHandler.Instance.GetText (textMeshItem.text);
	}




}