﻿using UnityEngine;
using AudioSystem;
using System.Collections;

/// <summary>
/// Simple Utility tool to set gameobject default state.
/// </summary>
public class ActivateOnAwake : MonoBehaviour
{
		public GameObject[] AwakeList;
		public GameObject[] DeAwakeList;

		public void Awake ()
		{
				foreach (GameObject goItem in AwakeList) {
						goItem.SetActive (true);
				}

				foreach (GameObject goItem in DeAwakeList) {
						goItem.SetActive (false);
				}
		}
}