﻿using UnityEngine;
using AudioSystem;
using System.Collections;
using System.Collections.Generic;

/// <summary>
/// The Objective multiple temp enablers was create as a utility tool that simply enables a selection of objects.
/// </summary>
public class ObjectiveMultipleTempEnablers : TaskHandler
{

		public List<GameObject> Objects = new List<GameObject> ();

		public float delay;

		public bool enableObjective;

		public override void EnableTask ()
		{

				string action = HRUtilities.EnableObjective;
				if (!enableObjective)
						action = HRUtilities.DisableObjective;

				for (int i = 0; i < Objects.Count; i++) {
						Objects [i].SendMessage (action);
				}

				StartCoroutine (EndTask ());
		}


		IEnumerator EndTask ()
		{
				yield return new WaitForSeconds (delay);

				SendTaskCompleted ();
		}




}
