﻿using UnityEngine;
using System.Collections;

public class DepthDebug : MonoBehaviour
{

	private Renderer _myRenderer;

	private Renderer myRenderer {
		get {
			if (_myRenderer == null)
				_myRenderer = GetComponent<Renderer> ();
			return _myRenderer;
		}   
		set {
			_myRenderer = value;
		}
	}


	private Material _myMaterial;

	private Material myMaterial {
		get {
			if (_myMaterial == null)
				_myMaterial = myRenderer.sharedMaterial;
			return _myMaterial;
		}   
		set {
			_myMaterial = value;
		}
	}


	void OnGUI ()
	{
		
		myMaterial.SetFloat ("_SeaDepthColor", GUI.HorizontalSlider (new Rect (20, 20, 2000, 100), myMaterial.GetFloat ("_SeaDepthColor"), 0.0F, 50F));
	}
}
