﻿using UnityEngine;
using System.Collections;

public class LightFlick : MonoBehaviour
{

	public float startAmount;
	public float flickAmount;
	public float flickSpeed;


	// Use this for initialization
	void Start ()
	{
		startAmount = myLight.intensity;
	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{
	
		float modifier = (Mathf.PerlinNoise (Time.time * flickSpeed, 3249) - 0.5f) * flickAmount;
		myLight.intensity = startAmount + modifier;

	}


	private Light _myLight;

	private Light myLight {
		get {
			if (_myLight == null)
				_myLight = GetComponent<Light> ();
			return _myLight;
		}   
		set {
			_myLight = value;
		}
	}

}
