﻿using UnityEngine;
using System.Collections;

public class LookAt : MonoBehaviour
{
	public Transform lookAt;

	public Vector3 offSet;
	public Vector3 rotOffSet;

	public bool useOnlyYAxis;

	// Use this for initialization
	void Start ()
	{
		
	}
	
	// Update is called once per frame
	void Update ()
	{
		if (!useOnlyYAxis) {
			myTransform.LookAt (lookAt.position + offSet);
		} else {
			Vector3 diff = lookAt.position - myTransform.position;
			Vector3 newRot = Quaternion.LookRotation (diff).eulerAngles + rotOffSet;
			newRot.x = 0;
			newRot.z = 0;
			myTransform.rotation = Quaternion.Euler (newRot);
		}
	}

	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}

}
