﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Rewired;

public class BoatHandler : MonoBehaviour
{

	public float maxTurnAngle;

	public float speed;


	// Use this for initialization
	void Start ()
	{
		
	}
	
	// Update is called once per frame
	void Update ()
	{
		float resultAngle = Mathf.Sin (Time.time * speed) * maxTurnAngle;
		myRigidbody2D.rotation = resultAngle;
	}


	private Rigidbody2D _myRigidbody2D;

	private Rigidbody2D myRigidbody2D {
		get {
			if (_myRigidbody2D == null)
				_myRigidbody2D = GetComponent<Rigidbody2D> ();
			return _myRigidbody2D;
		}   
		set {
			_myRigidbody2D = value;
		}
	}


	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}

}
