﻿using UnityEngine;
using System.Collections;
using Rewired;

public class ControlHandler : MonoBehaviour
{

	public float moveSpeed;
	public int playerId = 0;
	private Player player;
	// Use this for initialization
	void Start ()
	{
		player = ReInput.players.GetPlayer (playerId);
		Debug.Log (string.Format ("player : {0}", player));

	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{
		GetInput ();
	}


	public void GetInput ()
	{
		float xMove = player.GetAxis ("MoveX") * moveSpeed;
		float zMove = player.GetAxis ("MoveZ") * moveSpeed;
		Debug.Log (string.Format ("player.GetAxis (MoveX) : {0}", player.GetAxis ("MoveX")));
		Vector3 moveDir = new Vector3 (xMove, 0, zMove);
		myTransform.position += moveDir;
	}



	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}

}
