﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WhaleHandler : MonoBehaviour
{

	public float rotationSpeed;
	public bool isAcitve = false;
	public float freezeTime;


	public void Start ()
	{

		StartCoroutine (StartTheGame ());
	}


	IEnumerator StartTheGame ()
	{
		yield return new WaitForSeconds (20);
		isAcitve = true;
	}

	// Update is called once per frame
	void FixedUpdate ()
	{
		if (isAcitve) {
			float tracker = HRUtilities.ClampAngle (myTransform.rotation.eulerAngles.z);

			Debug.Log (string.Format ("tracker : {0}", tracker));

			Vector3 rot = myTransform.rotation.eulerAngles;
			rot.z += rotationSpeed;
			myTransform.rotation = Quaternion.Euler (rot);

			if (HRUtilities.ClampAngle (myTransform.rotation.eulerAngles.z) < 10 && HRUtilities.ClampAngle (myTransform.rotation.eulerAngles.z) > 0)
				StartCoroutine (PauseIt ());
		}
	}


	IEnumerator PauseIt ()
	{
		
		isAcitve = false;

		float freezeTimeResult = freezeTime + Random.Range (0, freezeTime);

		yield return new WaitForSeconds (freezeTimeResult);

		isAcitve = true;


		Vector3 rot = new Vector3 (0, 0, 90);
		rot.z += rotationSpeed;
		myTransform.rotation = Quaternion.Euler (rot);

	}





	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}

}
