﻿using UnityEngine;
using System.Collections;

public class AtmosphereColorEnforcer : MonoBehaviour
{

	public ColorSelection colorSelection;
	public Color resultColor;


	public void Awake ()
	{
		EnviormentHandler.instance.AddColorEnforcer (this);
	}

	public virtual void UpdateColorSettings ()
	{

		Color selectedColor = EnviormentHandler.instance.color1;

		if (colorSelection == ColorSelection.Color1)
			selectedColor = EnviormentHandler.instance.color1;
		else if (colorSelection == ColorSelection.Color2)
			selectedColor = EnviormentHandler.instance.color2;
		else if (colorSelection == ColorSelection.Color3)
			selectedColor = EnviormentHandler.instance.color3;
		else if (colorSelection == ColorSelection.Color4)
			selectedColor = EnviormentHandler.instance.color4;
		else if (colorSelection == ColorSelection.Color5)
			selectedColor = EnviormentHandler.instance.color5;


		resultColor = selectedColor;



	}


}


public enum ColorSelection
{

	Color1,
	Color2,
	Color3,
	Color4,
	Color5

}