﻿using UnityEngine;
using System.Collections;

public class AtmosphereLightColorHandler : AtmosphereColorEnforcer
{



	public override void UpdateColorSettings ()
	{
		base.UpdateColorSettings ();
		myLight.color = resultColor;
	}


	private Light _myLight;

	private Light myLight {
		get {
			if (_myLight == null)
				_myLight = GetComponent<Light> ();
			return _myLight;
		}   
		set {
			_myLight = value;
		}
	}


}