// Upgrade NOTE: replaced '_Object2World' with 'unity_ObjectToWorld'

// Shader created with Shader Forge v1.28 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.28;sub:START;pass:START;ps:flbk:,iptp:2,cusa:False,bamd:0,lico:0,lgpr:1,limd:0,spmd:1,trmd:0,grmd:0,uamb:True,mssp:True,bkdf:False,hqlp:False,rprd:False,enco:False,rmgx:True,rpth:0,vtps:0,hqsc:True,nrmq:1,nrsp:0,vomd:0,spxs:False,tesm:0,olmd:1,culm:0,bsrc:0,bdst:1,dpts:2,wrdp:True,dith:0,rfrpo:True,rfrpn:Refraction,coma:15,ufog:False,aust:False,igpj:True,qofs:0,qpre:0,rntp:1,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.3923551,fgcg:0.83834,fgcb:0.9044118,fgca:1,fgde:1,fgrn:20,fgrf:100,stcl:False,stva:128,stmr:255,stmw:255,stcp:6,stps:0,stfa:0,stfz:0,ofsf:0,ofsu:0,f2p0:False,fnsp:True,fnfb:True;n:type:ShaderForge.SFN_Final,id:3554,x:32480,y:32959,varname:node_3554,prsc:2|emission-7568-OUT;n:type:ShaderForge.SFN_Color,id:8306,x:31327,y:33009,ptovrint:False,ptlb:Sky Color,ptin:_SkyColor,varname:node_8306,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.02553246,c2:0.03709318,c3:0.1827586,c4:1;n:type:ShaderForge.SFN_ViewVector,id:2265,x:30716,y:33195,varname:node_2265,prsc:2;n:type:ShaderForge.SFN_Dot,id:7606,x:30973,y:33276,varname:node_7606,prsc:2,dt:1|A-2265-OUT,B-3211-OUT;n:type:ShaderForge.SFN_Vector3,id:3211,x:30716,y:33320,varname:node_3211,prsc:2,v1:0,v2:-1,v3:0;n:type:ShaderForge.SFN_Color,id:3839,x:31327,y:33171,ptovrint:False,ptlb:Horizon Color,ptin:_HorizonColor,varname:_GroundColor_copy,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.06617647,c2:0.5468207,c3:1,c4:1;n:type:ShaderForge.SFN_Power,id:4050,x:31327,y:33318,varname:node_4050,prsc:2|VAL-6125-OUT,EXP-7609-OUT;n:type:ShaderForge.SFN_Vector1,id:7609,x:31142,y:33418,varname:node_7609,prsc:2,v1:8;n:type:ShaderForge.SFN_OneMinus,id:6125,x:31142,y:33276,varname:node_6125,prsc:2|IN-7606-OUT;n:type:ShaderForge.SFN_Lerp,id:2737,x:31554,y:33192,cmnt:Sky,varname:node_2737,prsc:2|A-8306-RGB,B-3839-RGB,T-4050-OUT;n:type:ShaderForge.SFN_LightVector,id:3559,x:30971,y:33707,cmnt:Auto-adapts to your directional light,varname:node_3559,prsc:2;n:type:ShaderForge.SFN_Dot,id:1472,x:31330,y:33817,cmnt:Linear falloff to sun angle,varname:node_1472,prsc:2,dt:1|A-8269-OUT,B-8750-OUT;n:type:ShaderForge.SFN_ViewVector,id:8750,x:31143,y:33827,varname:node_8750,prsc:2;n:type:ShaderForge.SFN_Add,id:7568,x:32228,y:33014,cmnt:Sky plus Sun,varname:node_7568,prsc:2|A-5792-OUT,B-5855-OUT;n:type:ShaderForge.SFN_Negate,id:8269,x:31143,y:33707,varname:node_8269,prsc:2|IN-3559-OUT;n:type:ShaderForge.SFN_RemapRangeAdvanced,id:3001,x:31580,y:33817,cmnt:Modify radius of falloff,varname:node_3001,prsc:2|IN-1472-OUT,IMIN-1476-OUT,IMAX-1574-OUT,OMIN-9430-OUT,OMAX-6262-OUT;n:type:ShaderForge.SFN_Slider,id:2435,x:30568,y:34133,ptovrint:False,ptlb:Sun Radius B,ptin:_SunRadiusB,varname:node_2435,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.1,max:0.1;n:type:ShaderForge.SFN_Slider,id:3144,x:30568,y:34027,ptovrint:False,ptlb:Sun Radius A,ptin:_SunRadiusA,varname:_SunOuterRadius_copy,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:0.1;n:type:ShaderForge.SFN_Vector1,id:9430,x:31330,y:34277,varname:node_9430,prsc:2,v1:1;n:type:ShaderForge.SFN_Vector1,id:6262,x:31330,y:34335,varname:node_6262,prsc:2,v1:0;n:type:ShaderForge.SFN_Clamp01,id:7022,x:31753,y:33817,varname:node_7022,prsc:2|IN-3001-OUT;n:type:ShaderForge.SFN_OneMinus,id:1574,x:31330,y:34131,varname:node_1574,prsc:2|IN-8889-OUT;n:type:ShaderForge.SFN_OneMinus,id:1476,x:31330,y:33982,varname:node_1476,prsc:2|IN-3432-OUT;n:type:ShaderForge.SFN_Multiply,id:8889,x:31141,y:34131,varname:node_8889,prsc:2|A-9367-OUT,B-9367-OUT;n:type:ShaderForge.SFN_Multiply,id:3432,x:31141,y:33982,varname:node_3432,prsc:2|A-7933-OUT,B-7933-OUT;n:type:ShaderForge.SFN_Max,id:9367,x:30929,y:34131,varname:node_9367,prsc:2|A-3144-OUT,B-2435-OUT;n:type:ShaderForge.SFN_Min,id:7933,x:30929,y:33982,varname:node_7933,prsc:2|A-3144-OUT,B-2435-OUT;n:type:ShaderForge.SFN_Power,id:754,x:31964,y:33943,varname:node_754,prsc:2|VAL-7022-OUT,EXP-5929-OUT;n:type:ShaderForge.SFN_Vector1,id:5929,x:31753,y:33947,varname:node_5929,prsc:2,v1:5;n:type:ShaderForge.SFN_Multiply,id:5855,x:32149,y:33864,cmnt:Sun,varname:node_5855,prsc:2|A-2359-RGB,B-754-OUT,C-7055-OUT;n:type:ShaderForge.SFN_ValueProperty,id:7055,x:31964,y:34091,ptovrint:False,ptlb:Sun Intensity,ptin:_SunIntensity,varname:node_7055,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:2;n:type:ShaderForge.SFN_LightColor,id:2359,x:31964,y:33817,cmnt:Get color from directional light,varname:node_2359,prsc:2;n:type:ShaderForge.SFN_Tex2d,id:5025,x:30689,y:32516,ptovrint:False,ptlb:Main Texture 1,ptin:_MainTexture1,varname:node_5025,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,tex:9067b684aa8d54f39a95db8ba7c5f88e,ntxv:0,isnm:False|UVIN-5473-UVOUT;n:type:ShaderForge.SFN_TexCoord,id:3847,x:30420,y:32563,varname:node_3847,prsc:2,uv:0;n:type:ShaderForge.SFN_Panner,id:5473,x:30689,y:32686,varname:node_5473,prsc:2,spu:1,spv:0|UVIN-3847-UVOUT,DIST-7787-OUT;n:type:ShaderForge.SFN_Slider,id:921,x:30263,y:32878,ptovrint:False,ptlb:Clouds Scroll Speed 1,ptin:_CloudsScrollSpeed1,varname:node_921,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.1034708,max:1;n:type:ShaderForge.SFN_Time,id:5633,x:30195,y:32586,varname:node_5633,prsc:2;n:type:ShaderForge.SFN_Multiply,id:7787,x:30420,y:32717,varname:node_7787,prsc:2|A-5633-TSL,B-921-OUT;n:type:ShaderForge.SFN_Slider,id:8867,x:30930,y:32873,ptovrint:False,ptlb:Cloud Amount 1,ptin:_CloudAmount1,varname:node_8867,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.9447877,max:10;n:type:ShaderForge.SFN_Power,id:8381,x:30986,y:32537,varname:node_8381,prsc:2|VAL-5025-R,EXP-4351-OUT;n:type:ShaderForge.SFN_Clamp01,id:9651,x:31185,y:32537,varname:node_9651,prsc:2|IN-8381-OUT;n:type:ShaderForge.SFN_Multiply,id:4351,x:30973,y:32688,varname:node_4351,prsc:2|A-8867-OUT,B-8867-OUT;n:type:ShaderForge.SFN_Color,id:9164,x:31185,y:32688,ptovrint:False,ptlb:Cloud Color 1,ptin:_CloudColor1,varname:node_9164,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:1,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_Multiply,id:7241,x:31368,y:32537,varname:node_7241,prsc:2|A-9651-OUT,B-9164-RGB;n:type:ShaderForge.SFN_Tex2d,id:3182,x:30755,y:31914,ptovrint:False,ptlb:Main Texture 2,ptin:_MainTexture2,varname:_MainTexture2,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,tex:0ae585ff3551949a78bf153bc303aa7b,ntxv:0,isnm:False|UVIN-4306-UVOUT;n:type:ShaderForge.SFN_TexCoord,id:1445,x:30486,y:31961,varname:node_1445,prsc:2,uv:0;n:type:ShaderForge.SFN_Panner,id:4306,x:30755,y:32084,varname:node_4306,prsc:2,spu:1,spv:0|UVIN-1445-UVOUT,DIST-6054-OUT;n:type:ShaderForge.SFN_Slider,id:7216,x:30279,y:32279,ptovrint:False,ptlb:Clouds Scroll Speed 2,ptin:_CloudsScrollSpeed2,varname:_CloudsScrollSpeed2,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.1034708,max:1;n:type:ShaderForge.SFN_Time,id:230,x:30261,y:31984,varname:node_230,prsc:2;n:type:ShaderForge.SFN_Multiply,id:6054,x:30486,y:32115,varname:node_6054,prsc:2|A-230-TSL,B-7216-OUT;n:type:ShaderForge.SFN_Slider,id:1747,x:30996,y:32271,ptovrint:False,ptlb:Cloud Amount 2,ptin:_CloudAmount2,varname:_CloudAmount2,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.9447877,max:10;n:type:ShaderForge.SFN_Power,id:1847,x:31052,y:31935,varname:node_1847,prsc:2|VAL-3182-R,EXP-2067-OUT;n:type:ShaderForge.SFN_Clamp01,id:1678,x:31251,y:31935,varname:node_1678,prsc:2|IN-1847-OUT;n:type:ShaderForge.SFN_Multiply,id:2067,x:31039,y:32086,varname:node_2067,prsc:2|A-1747-OUT,B-1747-OUT;n:type:ShaderForge.SFN_Color,id:8661,x:31251,y:32086,ptovrint:False,ptlb:Cloud Color 2,ptin:_CloudColor2,varname:_CloudColor2,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:1,c3:0.5,c4:1;n:type:ShaderForge.SFN_Multiply,id:20,x:31434,y:31935,varname:node_20,prsc:2|A-1678-OUT,B-8661-RGB;n:type:ShaderForge.SFN_Blend,id:5482,x:31719,y:32752,varname:node_5482,prsc:2,blmd:6,clmp:True|SRC-2737-OUT,DST-7241-OUT;n:type:ShaderForge.SFN_Blend,id:6714,x:31672,y:32241,varname:node_6714,prsc:2,blmd:6,clmp:True|SRC-3217-OUT,DST-20-OUT;n:type:ShaderForge.SFN_Lerp,id:3217,x:31643,y:32572,varname:node_3217,prsc:2|A-2737-OUT,B-7241-OUT,T-5025-RGB;n:type:ShaderForge.SFN_Lerp,id:5792,x:31849,y:32125,varname:node_5792,prsc:2|A-3217-OUT,B-20-OUT,T-3182-RGB;proporder:8306-3839-2435-3144-7055-5025-921-8867-9164-3182-1747-8661-7216;pass:END;sub:END;*/

Shader "Another Circus/Sky Shader" {
    Properties {
        _SkyColor ("Sky Color", Color) = (0.02553246,0.03709318,0.1827586,1)
        _HorizonColor ("Horizon Color", Color) = (0.06617647,0.5468207,1,1)
        _SunRadiusB ("Sun Radius B", Range(0, 0.1)) = 0.1
        _SunRadiusA ("Sun Radius A", Range(0, 0.1)) = 0
        _SunIntensity ("Sun Intensity", Float ) = 2
        _MainTexture1 ("Main Texture 1", 2D) = "white" {}
        _CloudsScrollSpeed1 ("Clouds Scroll Speed 1", Range(0, 1)) = 0.1034708
        _CloudAmount1 ("Cloud Amount 1", Range(0, 10)) = 0.9447877
        _CloudColor1 ("Cloud Color 1", Color) = (1,0.5,0.5,1)
        _MainTexture2 ("Main Texture 2", 2D) = "white" {}
        _CloudAmount2 ("Cloud Amount 2", Range(0, 10)) = 0.9447877
        _CloudColor2 ("Cloud Color 2", Color) = (0.5,1,0.5,1)
        _CloudsScrollSpeed2 ("Clouds Scroll Speed 2", Range(0, 1)) = 0.1034708
    }
    SubShader {
        Tags {
            "IgnoreProjector"="True"
            "Queue"="Background"
            "RenderType"="Opaque"
            "PreviewType"="Skybox"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #include "UnityCG.cginc"
            #pragma multi_compile_fwdbase
            #pragma exclude_renderers d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform float4 _LightColor0;
            uniform float4 _TimeEditor;
            uniform float4 _SkyColor;
            uniform float4 _HorizonColor;
            uniform float _SunRadiusB;
            uniform float _SunRadiusA;
            uniform float _SunIntensity;
            uniform sampler2D _MainTexture1; uniform float4 _MainTexture1_ST;
            uniform float _CloudsScrollSpeed1;
            uniform float _CloudAmount1;
            uniform float4 _CloudColor1;
            uniform sampler2D _MainTexture2; uniform float4 _MainTexture2_ST;
            uniform float _CloudsScrollSpeed2;
            uniform float _CloudAmount2;
            uniform float4 _CloudColor2;
            struct VertexInput {
                float4 vertex : POSITION;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 lightDirection = normalize(_WorldSpaceLightPos0.xyz);
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
////// Emissive:
                float3 node_2737 = lerp(_SkyColor.rgb,_HorizonColor.rgb,pow((1.0 - max(0,dot(viewDirection,float3(0,-1,0)))),8.0)); // Sky
                float4 node_5633 = _Time + _TimeEditor;
                float2 node_5473 = (i.uv0+(node_5633.r*_CloudsScrollSpeed1)*float2(1,0));
                float4 _MainTexture1_var = tex2D(_MainTexture1,TRANSFORM_TEX(node_5473, _MainTexture1));
                float3 node_7241 = (saturate(pow(_MainTexture1_var.r,(_CloudAmount1*_CloudAmount1)))*_CloudColor1.rgb);
                float3 node_3217 = lerp(node_2737,node_7241,_MainTexture1_var.rgb);
                float4 node_230 = _Time + _TimeEditor;
                float2 node_4306 = (i.uv0+(node_230.r*_CloudsScrollSpeed2)*float2(1,0));
                float4 _MainTexture2_var = tex2D(_MainTexture2,TRANSFORM_TEX(node_4306, _MainTexture2));
                float3 node_20 = (saturate(pow(_MainTexture2_var.r,(_CloudAmount2*_CloudAmount2)))*_CloudColor2.rgb);
                float node_7933 = min(_SunRadiusA,_SunRadiusB);
                float node_1476 = (1.0 - (node_7933*node_7933));
                float node_9367 = max(_SunRadiusA,_SunRadiusB);
                float node_9430 = 1.0;
                float3 emissive = (lerp(node_3217,node_20,_MainTexture2_var.rgb)+(_LightColor0.rgb*pow(saturate((node_9430 + ( (max(0,dot((-1*lightDirection),viewDirection)) - node_1476) * (0.0 - node_9430) ) / ((1.0 - (node_9367*node_9367)) - node_1476))),5.0)*_SunIntensity));
                float3 finalColor = emissive;
                return fixed4(finalColor,1);
            }
            ENDCG
        }
    }
    CustomEditor "ShaderForgeMaterialInspector"
}
