// Shader created with Shader Forge v1.30 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.30;sub:START;pass:START;ps:flbk:,iptp:0,cusa:False,bamd:0,lico:1,lgpr:1,limd:1,spmd:0,trmd:1,grmd:0,uamb:False,mssp:True,bkdf:False,hqlp:False,rprd:False,enco:False,rmgx:True,rpth:0,vtps:0,hqsc:True,nrmq:1,nrsp:0,vomd:0,spxs:False,tesm:0,olmd:1,culm:0,bsrc:0,bdst:1,dpts:2,wrdp:False,dith:0,rfrpo:False,rfrpn:Refraction,coma:15,ufog:True,aust:False,igpj:False,qofs:0,qpre:3,rntp:2,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.6252162,fgcg:0.7272044,fgcb:0.8676471,fgca:1,fgde:0.003,fgrn:0,fgrf:300,stcl:False,stva:128,stmr:255,stmw:255,stcp:6,stps:0,stfa:0,stfz:0,ofsf:0,ofsu:0,f2p0:True,fnsp:False,fnfb:False;n:type:ShaderForge.SFN_Final,id:396,x:33598,y:32884,varname:node_396,prsc:2|diff-8210-OUT,spec-2780-OUT,gloss-5085-OUT,emission-3302-OUT,transm-7576-OUT,lwrap-8046-OUT,alpha-2533-OUT;n:type:ShaderForge.SFN_DepthBlend,id:562,x:32449,y:33921,varname:node_562,prsc:2|DIST-2296-OUT;n:type:ShaderForge.SFN_Slider,id:4526,x:32016,y:33734,ptovrint:False,ptlb:Sea Opacity,ptin:_SeaOpacity,cmnt:Sea Opacity,varname:_Opacityofftheocean,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.95,max:1;n:type:ShaderForge.SFN_Slider,id:5085,x:33353,y:32386,ptovrint:False,ptlb:Gloss,ptin:_Gloss,varname:_Gloss,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.7,max:1;n:type:ShaderForge.SFN_Multiply,id:2533,x:32439,y:33734,varname:node_2533,prsc:2|A-4526-OUT,B-562-OUT;n:type:ShaderForge.SFN_Slider,id:2296,x:32016,y:33920,ptovrint:False,ptlb:Sea Edge Width,ptin:_SeaEdgeWidth,cmnt:Sea Edge Width,varname:node_2296,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:15;n:type:ShaderForge.SFN_Tex2d,id:6849,x:31732,y:33225,ptovrint:False,ptlb:Sea Edge Foam,ptin:_SeaEdgeFoam,varname:node_6849,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False|UVIN-2904-OUT;n:type:ShaderForge.SFN_Slider,id:1983,x:31575,y:33429,ptovrint:False,ptlb:Sea Edge Depth,ptin:_SeaEdgeDepth,varname:node_1983,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:20;n:type:ShaderForge.SFN_DepthBlend,id:2989,x:31998,y:33430,varname:node_2989,prsc:2|DIST-1983-OUT;n:type:ShaderForge.SFN_RemapRange,id:7206,x:31998,y:33227,varname:node_7206,prsc:2,frmn:0,frmx:1,tomn:1,tomx:0|IN-2989-OUT;n:type:ShaderForge.SFN_FragmentPosition,id:2058,x:29951,y:33057,varname:node_2058,prsc:2;n:type:ShaderForge.SFN_Color,id:7080,x:31680,y:31062,ptovrint:False,ptlb:Sea Color Edge,ptin:_SeaColorEdge,cmnt:Deep And Shallow Color,varname:node_7080,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:1,c2:1,c3:1,c4:1;n:type:ShaderForge.SFN_Tex2d,id:3466,x:31635,y:31741,ptovrint:False,ptlb:Sea Texture,ptin:_SeaTexture,varname:node_3466,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False|UVIN-2904-OUT;n:type:ShaderForge.SFN_Multiply,id:6809,x:32462,y:31694,varname:node_6809,prsc:2|A-8251-OUT,B-3466-RGB;n:type:ShaderForge.SFN_Tex2d,id:9260,x:31645,y:32018,ptovrint:False,ptlb:Top Foam ,ptin:_TopFoam,varname:node_9260,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False|UVIN-2904-OUT;n:type:ShaderForge.SFN_Color,id:9934,x:31645,y:32250,ptovrint:False,ptlb:Top Foam Color,ptin:_TopFoamColor,varname:node_9934,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:1,c2:1,c3:1,c4:1;n:type:ShaderForge.SFN_Multiply,id:4798,x:31881,y:32172,varname:node_4798,prsc:2|A-9260-RGB,B-9934-RGB;n:type:ShaderForge.SFN_Lerp,id:3569,x:32409,y:32536,varname:node_3569,prsc:2|A-6809-OUT,B-4798-OUT,T-674-OUT;n:type:ShaderForge.SFN_Multiply,id:3302,x:32409,y:33308,varname:node_3302,prsc:2|A-8210-OUT,B-1866-OUT;n:type:ShaderForge.SFN_Slider,id:1866,x:32252,y:33445,ptovrint:False,ptlb:Emision Amount,ptin:_EmisionAmount,varname:node_1866,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:7576,x:33353,y:32250,ptovrint:False,ptlb:Transmission,ptin:_Transmission,varname:node_7576,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:8046,x:33353,y:32143,ptovrint:False,ptlb:LightWrapper,ptin:_LightWrapper,varname:node_8046,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Color,id:7839,x:31680,y:31234,ptovrint:False,ptlb:Sea Color Depth,ptin:_SeaColorDepth,varname:node_7839,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_Lerp,id:1526,x:32178,y:31086,varname:node_1526,prsc:2|A-7080-RGB,B-7839-RGB,T-1773-OUT;n:type:ShaderForge.SFN_DepthBlend,id:1773,x:31680,y:31402,varname:node_1773,prsc:2|DIST-7694-OUT;n:type:ShaderForge.SFN_Slider,id:7694,x:31352,y:31402,ptovrint:False,ptlb:Sea Depth Color,ptin:_SeaDepthColor,varname:node_7694,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:50;n:type:ShaderForge.SFN_Lerp,id:8210,x:32409,y:33089,cmnt:Mix Down,varname:node_8210,prsc:2|A-3569-OUT,B-5391-OUT,T-7206-OUT;n:type:ShaderForge.SFN_Color,id:5031,x:32178,y:30552,ptovrint:False,ptlb:Sea Side Color,ptin:_SeaSideColor,varname:node_5031,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_ComponentMask,id:7913,x:31770,y:30505,varname:node_7913,prsc:2,cc1:1,cc2:-1,cc3:-1,cc4:-1|IN-4492-OUT;n:type:ShaderForge.SFN_Lerp,id:8251,x:32483,y:30782,varname:node_8251,prsc:2|A-5031-RGB,B-1526-OUT,T-808-OUT;n:type:ShaderForge.SFN_NormalVector,id:4492,x:31601,y:30505,cmnt:Sea Side Color,prsc:2,pt:False;n:type:ShaderForge.SFN_Slider,id:1171,x:31613,y:30697,ptovrint:False,ptlb:Side Divide,ptin:_SideDivide,varname:node_1171,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:1,max:10;n:type:ShaderForge.SFN_Divide,id:8884,x:31994,y:30678,varname:node_8884,prsc:2|A-7913-OUT,B-1171-OUT;n:type:ShaderForge.SFN_Slider,id:7197,x:31613,y:30846,ptovrint:False,ptlb:Side Height,ptin:_SideHeight,varname:node_7197,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-10,cur:0,max:10;n:type:ShaderForge.SFN_Subtract,id:7757,x:31994,y:30825,varname:node_7757,prsc:2|A-8884-OUT,B-7197-OUT;n:type:ShaderForge.SFN_Clamp01,id:808,x:32171,y:30825,varname:node_808,prsc:2|IN-7757-OUT;n:type:ShaderForge.SFN_Slider,id:2312,x:30070,y:32650,ptovrint:False,ptlb:Sea Text panning X,ptin:_SeaTextpanningX,varname:node_2312,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-1,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:7445,x:30413,y:32656,ptovrint:False,ptlb:Sea Text panning Y,ptin:_SeaTextpanningY,varname:node_7445,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-1,cur:0,max:1;n:type:ShaderForge.SFN_TexCoord,id:9576,x:29898,y:32289,cmnt:Sea Movement,varname:node_9576,prsc:2,uv:0;n:type:ShaderForge.SFN_Panner,id:2496,x:30227,y:32288,varname:node_2496,prsc:2,spu:0,spv:1|UVIN-9576-UVOUT,DIST-3840-OUT;n:type:ShaderForge.SFN_Panner,id:4878,x:30570,y:32287,varname:node_4878,prsc:2,spu:1,spv:0|UVIN-2496-UVOUT,DIST-7653-OUT;n:type:ShaderForge.SFN_Time,id:392,x:29869,y:32501,varname:node_392,prsc:2;n:type:ShaderForge.SFN_Multiply,id:3840,x:30227,y:32493,varname:node_3840,prsc:2|A-392-TSL,B-2312-OUT;n:type:ShaderForge.SFN_Multiply,id:7653,x:30570,y:32494,varname:node_7653,prsc:2|A-392-TSL,B-7445-OUT;n:type:ShaderForge.SFN_Tex2d,id:3885,x:29481,y:33232,ptovrint:False,ptlb:Top Foam Mix Texture,ptin:_TopFoamMixTexture,cmnt:Top Foam Texture Mix,varname:node_3885,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False|UVIN-4878-UVOUT;n:type:ShaderForge.SFN_ComponentMask,id:1497,x:29698,y:33219,varname:node_1497,prsc:2,cc1:0,cc2:-1,cc3:-1,cc4:-1|IN-3885-A;n:type:ShaderForge.SFN_Multiply,id:6316,x:29951,y:33219,varname:node_6316,prsc:2|A-1497-OUT,B-2058-Y,C-7718-OUT;n:type:ShaderForge.SFN_Slider,id:7718,x:29794,y:33437,ptovrint:False,ptlb:Multiply Val 1,ptin:_MultiplyVal1,varname:node_7718,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:3867,x:30010,y:33535,ptovrint:False,ptlb:Divide Val 2,ptin:_DivideVal2,varname:node_3867,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Divide,id:9224,x:30160,y:33219,varname:node_9224,prsc:2|A-6316-OUT,B-3867-OUT;n:type:ShaderForge.SFN_Subtract,id:6169,x:30397,y:33219,varname:node_6169,prsc:2|A-9224-OUT,B-8691-OUT;n:type:ShaderForge.SFN_Slider,id:8691,x:30240,y:33432,ptovrint:False,ptlb:Subtrack Val 3,ptin:_SubtrackVal3,varname:node_8691,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Relay,id:674,x:31427,y:32896,varname:node_674,prsc:2|IN-9830-OUT;n:type:ShaderForge.SFN_Clamp01,id:9830,x:30615,y:33219,varname:node_9830,prsc:2|IN-6169-OUT;n:type:ShaderForge.SFN_Color,id:8447,x:31732,y:33017,ptovrint:False,ptlb:Sea Edge Foam Color,ptin:_SeaEdgeFoamColor,cmnt:Sea Edges,varname:node_8447,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:1,c2:1,c3:1,c4:1;n:type:ShaderForge.SFN_Multiply,id:5391,x:31998,y:33010,varname:node_5391,prsc:2|A-8447-RGB,B-6849-RGB;n:type:ShaderForge.SFN_Relay,id:2904,x:31369,y:32317,varname:node_2904,prsc:2|IN-4878-UVOUT;n:type:ShaderForge.SFN_Tex2d,id:8019,x:32121,y:34156,ptovrint:False,ptlb:Specular Texture,ptin:_SpecularTexture,varname:node_8019,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False|UVIN-2904-OUT;n:type:ShaderForge.SFN_Color,id:6577,x:32121,y:34350,ptovrint:False,ptlb:Specular Color,ptin:_SpecularColor,varname:node_6577,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_Multiply,id:2780,x:32427,y:34253,varname:node_2780,prsc:2|A-8019-RGB,B-6577-RGB;proporder:4526-7080-7839-7694-3466-2296-1983-8447-6849-9934-9260-5031-1171-7197-2312-7445-3885-7718-3867-8691-1866-7576-8046-5085-8019-6577;pass:END;sub:END;*/

Shader "Another Circus/Water_Side" {
    Properties {
        _SeaOpacity ("Sea Opacity", Range(0, 1)) = 0.95
        _SeaColorEdge ("Sea Color Edge", Color) = (1,1,1,1)
        _SeaColorDepth ("Sea Color Depth", Color) = (0.5,0.5,0.5,1)
        _SeaDepthColor ("Sea Depth Color", Range(0, 50)) = 0
        _SeaTexture ("Sea Texture", 2D) = "white" {}
        _SeaEdgeWidth ("Sea Edge Width", Range(0, 15)) = 0
        _SeaEdgeDepth ("Sea Edge Depth", Range(0, 20)) = 0
        _SeaEdgeFoamColor ("Sea Edge Foam Color", Color) = (1,1,1,1)
        _SeaEdgeFoam ("Sea Edge Foam", 2D) = "white" {}
        _TopFoamColor ("Top Foam Color", Color) = (1,1,1,1)
        _TopFoam ("Top Foam ", 2D) = "white" {}
        _SeaSideColor ("Sea Side Color", Color) = (0,0.5,0.5,1)
        _SideDivide ("Side Divide", Range(0, 10)) = 1
        _SideHeight ("Side Height", Range(-10, 10)) = 0
        _SeaTextpanningX ("Sea Text panning X", Range(-1, 1)) = 0
        _SeaTextpanningY ("Sea Text panning Y", Range(-1, 1)) = 0
        _TopFoamMixTexture ("Top Foam Mix Texture", 2D) = "white" {}
        _MultiplyVal1 ("Multiply Val 1", Range(0, 1)) = 0
        _DivideVal2 ("Divide Val 2", Range(0, 1)) = 0
        _SubtrackVal3 ("Subtrack Val 3", Range(0, 1)) = 0
        _EmisionAmount ("Emision Amount", Range(0, 1)) = 0
        _Transmission ("Transmission", Range(0, 1)) = 0
        _LightWrapper ("LightWrapper", Range(0, 1)) = 0
        _Gloss ("Gloss", Range(0, 1)) = 0.7
        _SpecularTexture ("Specular Texture", 2D) = "white" {}
        _SpecularColor ("Specular Color", Color) = (0.5,0.5,0.5,1)
        [HideInInspector]_Cutoff ("Alpha cutoff", Range(0,1)) = 0.5
    }
    SubShader {
        Tags {
            "Queue"="Transparent"
            "RenderType"="Transparent"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #pragma multi_compile_fwdbase_fullshadows
            #pragma multi_compile_fog
            #pragma exclude_renderers xbox360 xboxone ps3 ps4 psp2 
            #pragma target 2.0
            uniform float4 _LightColor0;
            uniform sampler2D _CameraDepthTexture;
            uniform float4 _TimeEditor;
            uniform float _SeaOpacity;
            uniform float _Gloss;
            uniform float _SeaEdgeWidth;
            uniform sampler2D _SeaEdgeFoam; uniform float4 _SeaEdgeFoam_ST;
            uniform float _SeaEdgeDepth;
            uniform float4 _SeaColorEdge;
            uniform sampler2D _SeaTexture; uniform float4 _SeaTexture_ST;
            uniform sampler2D _TopFoam; uniform float4 _TopFoam_ST;
            uniform float4 _TopFoamColor;
            uniform float _EmisionAmount;
            uniform float _Transmission;
            uniform float _LightWrapper;
            uniform float4 _SeaColorDepth;
            uniform float _SeaDepthColor;
            uniform float4 _SeaSideColor;
            uniform float _SideDivide;
            uniform float _SideHeight;
            uniform float _SeaTextpanningX;
            uniform float _SeaTextpanningY;
            uniform sampler2D _TopFoamMixTexture; uniform float4 _TopFoamMixTexture_ST;
            uniform float _MultiplyVal1;
            uniform float _DivideVal2;
            uniform float _SubtrackVal3;
            uniform float4 _SeaEdgeFoamColor;
            uniform sampler2D _SpecularTexture; uniform float4 _SpecularTexture_ST;
            uniform float4 _SpecularColor;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
                float3 normalDir : TEXCOORD2;
                float4 projPos : TEXCOORD3;
                LIGHTING_COORDS(4,5)
                UNITY_FOG_COORDS(6)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(_Object2World, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                o.projPos = ComputeScreenPos (o.pos);
                COMPUTE_EYEDEPTH(o.projPos.z);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float sceneZ = max(0,LinearEyeDepth (UNITY_SAMPLE_DEPTH(tex2Dproj(_CameraDepthTexture, UNITY_PROJ_COORD(i.projPos)))) - _ProjectionParams.g);
                float partZ = max(0,i.projPos.z - _ProjectionParams.g);
                float3 lightDirection = normalize(_WorldSpaceLightPos0.xyz);
                float3 lightColor = _LightColor0.rgb;
                float3 halfDirection = normalize(viewDirection+lightDirection);
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
///////// Gloss:
                float gloss = _Gloss;
                float specPow = exp2( gloss * 10.0+1.0);
////// Specular:
                float NdotL = max(0, dot( normalDirection, lightDirection ));
                float4 node_392 = _Time + _TimeEditor;
                float2 node_4878 = ((i.uv0+(node_392.r*_SeaTextpanningX)*float2(0,1))+(node_392.r*_SeaTextpanningY)*float2(1,0));
                float2 node_2904 = node_4878;
                float4 _SpecularTexture_var = tex2D(_SpecularTexture,TRANSFORM_TEX(node_2904, _SpecularTexture));
                float3 specularColor = (_SpecularTexture_var.rgb*_SpecularColor.rgb);
                float3 directSpecular = (floor(attenuation) * _LightColor0.xyz) * pow(max(0,dot(halfDirection,normalDirection)),specPow)*specularColor;
                float3 specular = directSpecular;
/////// Diffuse:
                NdotL = dot( normalDirection, lightDirection );
                float3 w = float3(_LightWrapper,_LightWrapper,_LightWrapper)*0.5; // Light wrapping
                float3 NdotLWrap = NdotL * ( 1.0 - w );
                float3 forwardLight = max(float3(0.0,0.0,0.0), NdotLWrap + w );
                float3 backLight = max(float3(0.0,0.0,0.0), -NdotLWrap + w ) * float3(_Transmission,_Transmission,_Transmission);
                NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = (forwardLight+backLight) * attenColor;
                float4 _SeaTexture_var = tex2D(_SeaTexture,TRANSFORM_TEX(node_2904, _SeaTexture));
                float4 _TopFoam_var = tex2D(_TopFoam,TRANSFORM_TEX(node_2904, _TopFoam));
                float4 _TopFoamMixTexture_var = tex2D(_TopFoamMixTexture,TRANSFORM_TEX(node_4878, _TopFoamMixTexture)); // Top Foam Texture Mix
                float4 _SeaEdgeFoam_var = tex2D(_SeaEdgeFoam,TRANSFORM_TEX(node_2904, _SeaEdgeFoam));
                float3 node_8210 = lerp(lerp((lerp(_SeaSideColor.rgb,lerp(_SeaColorEdge.rgb,_SeaColorDepth.rgb,saturate((sceneZ-partZ)/_SeaDepthColor)),saturate(((i.normalDir.g/_SideDivide)-_SideHeight)))*_SeaTexture_var.rgb),(_TopFoam_var.rgb*_TopFoamColor.rgb),saturate((((_TopFoamMixTexture_var.a.r*i.posWorld.g*_MultiplyVal1)/_DivideVal2)-_SubtrackVal3))),(_SeaEdgeFoamColor.rgb*_SeaEdgeFoam_var.rgb),(saturate((sceneZ-partZ)/_SeaEdgeDepth)*-1.0+1.0)); // Mix Down
                float3 diffuseColor = node_8210;
                float3 diffuse = directDiffuse * diffuseColor;
////// Emissive:
                float3 emissive = (node_8210*_EmisionAmount);
/// Final Color:
                float3 finalColor = diffuse * (_SeaOpacity*saturate((sceneZ-partZ)/_SeaEdgeWidth)) + specular + emissive;
                fixed4 finalRGBA = fixed4(finalColor,(_SeaOpacity*saturate((sceneZ-partZ)/_SeaEdgeWidth)));
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "FORWARD_DELTA"
            Tags {
                "LightMode"="ForwardAdd"
            }
            Blend One One
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDADD
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #pragma multi_compile_fwdadd_fullshadows
            #pragma multi_compile_fog
            #pragma exclude_renderers xbox360 xboxone ps3 ps4 psp2 
            #pragma target 2.0
            uniform float4 _LightColor0;
            uniform sampler2D _CameraDepthTexture;
            uniform float4 _TimeEditor;
            uniform float _SeaOpacity;
            uniform float _Gloss;
            uniform float _SeaEdgeWidth;
            uniform sampler2D _SeaEdgeFoam; uniform float4 _SeaEdgeFoam_ST;
            uniform float _SeaEdgeDepth;
            uniform float4 _SeaColorEdge;
            uniform sampler2D _SeaTexture; uniform float4 _SeaTexture_ST;
            uniform sampler2D _TopFoam; uniform float4 _TopFoam_ST;
            uniform float4 _TopFoamColor;
            uniform float _EmisionAmount;
            uniform float _Transmission;
            uniform float _LightWrapper;
            uniform float4 _SeaColorDepth;
            uniform float _SeaDepthColor;
            uniform float4 _SeaSideColor;
            uniform float _SideDivide;
            uniform float _SideHeight;
            uniform float _SeaTextpanningX;
            uniform float _SeaTextpanningY;
            uniform sampler2D _TopFoamMixTexture; uniform float4 _TopFoamMixTexture_ST;
            uniform float _MultiplyVal1;
            uniform float _DivideVal2;
            uniform float _SubtrackVal3;
            uniform float4 _SeaEdgeFoamColor;
            uniform sampler2D _SpecularTexture; uniform float4 _SpecularTexture_ST;
            uniform float4 _SpecularColor;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
                float3 normalDir : TEXCOORD2;
                float4 projPos : TEXCOORD3;
                LIGHTING_COORDS(4,5)
                UNITY_FOG_COORDS(6)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(_Object2World, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                o.projPos = ComputeScreenPos (o.pos);
                COMPUTE_EYEDEPTH(o.projPos.z);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float sceneZ = max(0,LinearEyeDepth (UNITY_SAMPLE_DEPTH(tex2Dproj(_CameraDepthTexture, UNITY_PROJ_COORD(i.projPos)))) - _ProjectionParams.g);
                float partZ = max(0,i.projPos.z - _ProjectionParams.g);
                float3 lightDirection = normalize(lerp(_WorldSpaceLightPos0.xyz, _WorldSpaceLightPos0.xyz - i.posWorld.xyz,_WorldSpaceLightPos0.w));
                float3 lightColor = _LightColor0.rgb;
                float3 halfDirection = normalize(viewDirection+lightDirection);
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
///////// Gloss:
                float gloss = _Gloss;
                float specPow = exp2( gloss * 10.0+1.0);
////// Specular:
                float NdotL = max(0, dot( normalDirection, lightDirection ));
                float4 node_392 = _Time + _TimeEditor;
                float2 node_4878 = ((i.uv0+(node_392.r*_SeaTextpanningX)*float2(0,1))+(node_392.r*_SeaTextpanningY)*float2(1,0));
                float2 node_2904 = node_4878;
                float4 _SpecularTexture_var = tex2D(_SpecularTexture,TRANSFORM_TEX(node_2904, _SpecularTexture));
                float3 specularColor = (_SpecularTexture_var.rgb*_SpecularColor.rgb);
                float3 directSpecular = attenColor * pow(max(0,dot(halfDirection,normalDirection)),specPow)*specularColor;
                float3 specular = directSpecular;
/////// Diffuse:
                NdotL = dot( normalDirection, lightDirection );
                float3 w = float3(_LightWrapper,_LightWrapper,_LightWrapper)*0.5; // Light wrapping
                float3 NdotLWrap = NdotL * ( 1.0 - w );
                float3 forwardLight = max(float3(0.0,0.0,0.0), NdotLWrap + w );
                float3 backLight = max(float3(0.0,0.0,0.0), -NdotLWrap + w ) * float3(_Transmission,_Transmission,_Transmission);
                NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = (forwardLight+backLight) * attenColor;
                float4 _SeaTexture_var = tex2D(_SeaTexture,TRANSFORM_TEX(node_2904, _SeaTexture));
                float4 _TopFoam_var = tex2D(_TopFoam,TRANSFORM_TEX(node_2904, _TopFoam));
                float4 _TopFoamMixTexture_var = tex2D(_TopFoamMixTexture,TRANSFORM_TEX(node_4878, _TopFoamMixTexture)); // Top Foam Texture Mix
                float4 _SeaEdgeFoam_var = tex2D(_SeaEdgeFoam,TRANSFORM_TEX(node_2904, _SeaEdgeFoam));
                float3 node_8210 = lerp(lerp((lerp(_SeaSideColor.rgb,lerp(_SeaColorEdge.rgb,_SeaColorDepth.rgb,saturate((sceneZ-partZ)/_SeaDepthColor)),saturate(((i.normalDir.g/_SideDivide)-_SideHeight)))*_SeaTexture_var.rgb),(_TopFoam_var.rgb*_TopFoamColor.rgb),saturate((((_TopFoamMixTexture_var.a.r*i.posWorld.g*_MultiplyVal1)/_DivideVal2)-_SubtrackVal3))),(_SeaEdgeFoamColor.rgb*_SeaEdgeFoam_var.rgb),(saturate((sceneZ-partZ)/_SeaEdgeDepth)*-1.0+1.0)); // Mix Down
                float3 diffuseColor = node_8210;
                float3 diffuse = directDiffuse * diffuseColor;
/// Final Color:
                float3 finalColor = diffuse * (_SeaOpacity*saturate((sceneZ-partZ)/_SeaEdgeWidth)) + specular;
                fixed4 finalRGBA = fixed4(finalColor,0);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
    CustomEditor "ShaderForgeMaterialInspector"
}
