﻿using UnityEngine;
using AudioSystem;
using System.Collections;
using System.Collections.Generic;

[System.Serializable]
/// <summary>
/// The Text class is a helper Text class tha contains the text for each language for each text entry
/// </summary>
public class TextClass
{
		public string code;
		public List<string> text = new List<string> ();

		public TextClass (string _code)
		{
				this.code = _code;
		}

		public void AddText (string _text)
		{
				this.text.Add (_text);
		}

		
		public string GetText (int langMode = 0)
		{

				if (langMode < text.Count)
						return text [langMode];
				else
						return text [0];
		}
		

}
