﻿using UnityEngine;
using UnityEngine.Events;
using UnityEngine.EventSystems;
using AudioSystem;
using System.Collections;

/// <summary>
/// Simple script that plays a sound On click .
/// </summary>
public class OnClickSound : MonoBehaviour  , IPointerClickHandler
{

	public string soundLabel;

	public void OnPointerClick (PointerEventData eventData)
	{
		AudioManager.PlaySfx (soundLabel);
	}
}
