﻿using UnityEngine;
using System.Collections;

[System.Serializable , CreateAssetMenu (menuName = "Another Circus/Camera Settings")]
public class CameraSettingsClass : ScriptableObject
{
	[Range (0, 3)]
	public float
		smoothFollow;

	[Range (0, 3)]
	public float
		smoothFollowRot;


	public Vector3 offset = new Vector3 ();
	public Vector3 rotationOffset = new Vector3 ();
	public float fieldOfView = 60;

	public bool rotationLock = true;
	public bool followTarget = true;


}
