﻿using UnityEngine;
using System.Collections;
using Spine.Unity;
using Spine.Unity.Modules;
using Spine;

public class LookAtYrotation : MonoBehaviour
{


	SkeletonRenderer skeletonRenderer;


	[Header ("Skin Settings")]
	public string straightSkin;
	public string turnSkin;
	public string currSkin;

	public float tiltHeadrotationBounds;



	// Update is called once per frame
	void FixedUpdate ()
	{

		float parentRot = myParentTransform.rotation.eulerAngles.y;
		
		Vector3 newRot = new Vector3 (0, HRUtilities.ClampAngle (-parentRot), 0);

		Quaternion rot = Quaternion.Euler (newRot);

		myTransform.localRotation = rot;

	}




	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}


	private Transform _myParentTransform;

	private Transform myParentTransform {
		get {
			if (_myParentTransform == null)
				_myParentTransform = myTransform.parent;
			return _myParentTransform;
		}

		set {
			_myTransform = value;
		}

	}

}
