﻿using UnityEngine;
using System.Collections;

public class SlowRotation : MonoBehaviour
{

	public Vector3 rotationSpeed;

	// Use this for initialization
	void Start ()
	{
	
	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{

		Vector3 rotationVector = myTransform.rotation.eulerAngles + rotationSpeed;
		Quaternion rotationQuant = Quaternion.Euler (rotationVector);
		myTransform.rotation = rotationQuant;
	
	}


	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}


}
