﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class GameController : MonoBehaviour
{

	public List<PlayerControl> playerInGame = new List<PlayerControl> ();
	public List<UiScoreHAndler> textfields = new List<UiScoreHAndler> ();
	public bool boatFlipped = false;


	public GameObject gameOverScreen;

	public float deathCost;

	public void RestartGame ()
	{
		SceneManager.LoadScene (SceneManager.GetActiveScene ().name);
	}



	public AudioSource mainMusic;
	public AudioSource gameOVerSource;

	public void PlayGameOverMusic ()
	{
		mainMusic.Stop ();
		gameOVerSource.Play ();

	}

	//public GameController

	public static GameController instance;


	void Awake ()
	{
		instance = this;
	}

	// Use this for initialization
	void Start ()
	{
		
	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{


		for (int i = 0; i < playerInGame.Count; i++) {
			if (playerInGame [i].isActive) {
				if (!textfields [i].gameObject.activeInHierarchy)
					textfields [i].gameObject.SetActive (true);

				textfields [i].SetScore (playerInGame [i].score);
			} else {
				if (textfields [i].gameObject.activeInHierarchy)
					textfields [i].gameObject.SetActive (false);
			}
		}


		/*
		for (int i = 0; i < playerInGame.Count; i++) {
			if (playerInGame [i].isActive) {
				if (!textfields [i].gameObject.activeInHierarchy)
					textfields [i].gameObject.SetActive (true);
				textfields [i].text = playerInGame [i].score.ToString ();
			} else {
				if (textfields [i].gameObject.activeInHierarchy)
					textfields [i].gameObject.SetActive (false);
			}
		}*/
	}
}
