﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PickableItem : MonoBehaviour
{


	public float value;

	public bool isActive = true;
	private Animator _myAnimator;

	private Animator myAnimator {
		get {
			if (_myAnimator == null)
				_myAnimator = GetComponent<Animator> ();
			return _myAnimator;
		}   
		set {
			_myAnimator = value;
		}
	}


	// Use this for initialization
	void Start ()
	{
		
	}
	
	// Update is called once per frame
	void Update ()
	{
		
	}

	public void OnTriggerEnter2D (Collider2D other)
	{
		if (other.tag == "Player" && isActive) {
			isActive = false;
			PlayerControl player = other.GetComponent<PlayerControl> ();
			player.AddScore (value);

			myAnimator.SetBool ("PickedUP", true);
			myTransform.localScale *= 2;
			Destroy (this.gameObject, 0.3f);
		}

	}

	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}


}
