// Upgrade NOTE: replaced '_Object2World' with 'unity_ObjectToWorld'

// Shader created with Shader Forge v1.28 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.28;sub:START;pass:START;ps:flbk:,iptp:1,cusa:True,bamd:0,lico:1,lgpr:1,limd:1,spmd:1,trmd:0,grmd:0,uamb:True,mssp:True,bkdf:False,hqlp:False,rprd:True,enco:False,rmgx:True,rpth:0,vtps:0,hqsc:True,nrmq:0,nrsp:0,vomd:0,spxs:False,tesm:0,olmd:1,culm:2,bsrc:0,bdst:1,dpts:2,wrdp:False,dith:0,rfrpo:False,rfrpn:Refraction,coma:15,ufog:True,aust:False,igpj:True,qofs:0,qpre:3,rntp:2,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.5,fgcg:0.5,fgcb:0.5,fgca:1,fgde:0.01,fgrn:0,fgrf:300,stcl:False,stva:128,stmr:255,stmw:255,stcp:6,stps:0,stfa:0,stfz:0,ofsf:0,ofsu:0,f2p0:False,fnsp:False,fnfb:False;n:type:ShaderForge.SFN_Final,id:2865,x:32677,y:32278,varname:node_2865,prsc:2|diff-6990-OUT,emission-3627-OUT,transm-4819-OUT,lwrap-8979-OUT,alpha-295-OUT,clip-5016-OUT;n:type:ShaderForge.SFN_Color,id:6665,x:31339,y:32462,ptovrint:False,ptlb:Color,ptin:_Color,varname:_Color,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:1,c2:1,c3:1,c4:1;n:type:ShaderForge.SFN_Tex2d,id:7736,x:31339,y:32271,ptovrint:True,ptlb:MainTex,ptin:_MainTex,varname:_MainTex,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False;n:type:ShaderForge.SFN_Multiply,id:295,x:31867,y:32423,varname:node_295,prsc:2|A-7736-A,B-6665-A;n:type:ShaderForge.SFN_Multiply,id:6990,x:32191,y:32271,varname:node_6990,prsc:2|A-7439-OUT,B-295-OUT;n:type:ShaderForge.SFN_Multiply,id:334,x:31602,y:32266,varname:node_334,prsc:2|A-7736-RGB,B-6665-RGB;n:type:ShaderForge.SFN_Slider,id:8979,x:32148,y:32124,ptovrint:False,ptlb:LightWrapping,ptin:_LightWrapping,varname:node_8979,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:4819,x:32148,y:32034,ptovrint:False,ptlb:Transmission,ptin:_Transmission,varname:node_4819,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Slider,id:3571,x:31798,y:32766,ptovrint:False,ptlb:Cut Amount,ptin:_CutAmount,varname:node_3571,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Multiply,id:5016,x:32207,y:32605,varname:node_5016,prsc:2|A-295-OUT,B-3571-OUT;n:type:ShaderForge.SFN_Tex2d,id:4641,x:31339,y:32046,ptovrint:False,ptlb:AnimTexture,ptin:_AnimTexture,varname:node_4641,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,tex:789b317d159bd4f259e6d7f87728da41,ntxv:0,isnm:False|UVIN-4937-UVOUT;n:type:ShaderForge.SFN_Blend,id:7439,x:31867,y:32260,varname:node_7439,prsc:2,blmd:6,clmp:True|SRC-334-OUT,DST-6852-OUT;n:type:ShaderForge.SFN_Color,id:2159,x:31339,y:31844,ptovrint:False,ptlb:AnimColor,ptin:_AnimColor,varname:node_2159,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_Multiply,id:6852,x:31589,y:32046,varname:node_6852,prsc:2|A-2159-RGB,B-4641-RGB,C-412-OUT;n:type:ShaderForge.SFN_FragmentPosition,id:9390,x:29964,y:31666,varname:node_9390,prsc:2;n:type:ShaderForge.SFN_ComponentMask,id:1939,x:30329,y:31666,varname:node_1939,prsc:2,cc1:0,cc2:1,cc3:-1,cc4:-1|IN-3689-OUT;n:type:ShaderForge.SFN_Multiply,id:3689,x:30160,y:31666,varname:node_3689,prsc:2|A-9390-XYZ,B-6563-OUT;n:type:ShaderForge.SFN_Slider,id:6563,x:29964,y:31873,ptovrint:False,ptlb:WaterTilling,ptin:_WaterTilling,varname:node_6563,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:1,max:1;n:type:ShaderForge.SFN_Vector1,id:900,x:30640,y:32024,varname:node_900,prsc:2,v1:1;n:type:ShaderForge.SFN_Add,id:6948,x:30865,y:31672,varname:node_6948,prsc:2|A-4644-OUT,B-900-OUT;n:type:ShaderForge.SFN_Time,id:1646,x:30875,y:31879,varname:node_1646,prsc:2;n:type:ShaderForge.SFN_ValueProperty,id:4242,x:30875,y:32089,ptovrint:False,ptlb:Water Speed 01,ptin:_WaterSpeed01,varname:node_4242,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:0;n:type:ShaderForge.SFN_Multiply,id:3113,x:31100,y:31902,varname:node_3113,prsc:2|A-1646-T,B-4242-OUT;n:type:ShaderForge.SFN_Panner,id:4937,x:31100,y:31672,varname:node_4937,prsc:2,spu:0,spv:1|UVIN-6948-OUT,DIST-3113-OUT;n:type:ShaderForge.SFN_Tex2d,id:6301,x:29952,y:31312,ptovrint:False,ptlb:Refraction,ptin:_Refraction,varname:node_6301,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,tex:1829dfd0e06404ad7963f684804594be,ntxv:3,isnm:True;n:type:ShaderForge.SFN_ComponentMask,id:7154,x:30189,y:31386,varname:node_7154,prsc:2,cc1:0,cc2:2,cc3:-1,cc4:-1|IN-6301-RGB;n:type:ShaderForge.SFN_Slider,id:2785,x:30189,y:31302,ptovrint:False,ptlb:RefractAmount,ptin:_RefractAmount,varname:node_2785,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0.4965132,max:1;n:type:ShaderForge.SFN_Vector2,id:4165,x:30189,y:31529,varname:node_4165,prsc:2,v1:0,v2:0;n:type:ShaderForge.SFN_Lerp,id:8400,x:30404,y:31440,varname:node_8400,prsc:2|A-4165-OUT,B-7154-OUT,T-2785-OUT;n:type:ShaderForge.SFN_Append,id:7618,x:30640,y:31742,varname:node_7618,prsc:2|A-8400-OUT,B-1939-OUT;n:type:ShaderForge.SFN_FragmentPosition,id:6782,x:29510,y:31251,varname:node_6782,prsc:2;n:type:ShaderForge.SFN_ComponentMask,id:605,x:29742,y:31312,varname:node_605,prsc:2,cc1:0,cc2:1,cc3:-1,cc4:-1|IN-6782-XYZ;n:type:ShaderForge.SFN_Multiply,id:6901,x:30640,y:31637,varname:node_6901,prsc:2|A-8400-OUT,B-1939-OUT;n:type:ShaderForge.SFN_Add,id:4644,x:30640,y:31861,varname:node_4644,prsc:2|A-1939-OUT,B-8400-OUT;n:type:ShaderForge.SFN_Subtract,id:8785,x:31662,y:31716,varname:node_8785,prsc:2|A-2584-OUT,B-6145-OUT;n:type:ShaderForge.SFN_Relay,id:3583,x:31339,y:31672,varname:node_3583,prsc:2|IN-9390-Y;n:type:ShaderForge.SFN_Slider,id:2584,x:31537,y:31514,ptovrint:False,ptlb:RefractGrandHeight,ptin:_RefractGrandHeight,varname:node_2584,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-20,cur:1,max:20;n:type:ShaderForge.SFN_Clamp01,id:412,x:31850,y:31733,varname:node_412,prsc:2|IN-8785-OUT;n:type:ShaderForge.SFN_Slider,id:4665,x:31145,y:31559,ptovrint:False,ptlb:RefractGrandSmooth,ptin:_RefractGrandSmooth,varname:node_4665,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-10,cur:1,max:10;n:type:ShaderForge.SFN_Multiply,id:6145,x:31459,y:31695,varname:node_6145,prsc:2|A-4665-OUT,B-3583-OUT;n:type:ShaderForge.SFN_Tex2d,id:2835,x:32253,y:32778,ptovrint:False,ptlb:EmissionTexture,ptin:_EmissionTexture,varname:node_2835,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False;n:type:ShaderForge.SFN_Slider,id:7594,x:32196,y:33013,ptovrint:False,ptlb:EmissionAmount,ptin:_EmissionAmount,varname:node_7594,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:0,cur:0,max:1;n:type:ShaderForge.SFN_Multiply,id:3627,x:32434,y:32894,varname:node_3627,prsc:2|A-2835-RGB,B-7594-OUT;proporder:7736-6665-8979-4819-3571-4641-2159-6563-4242-6301-2785-2584-4665-2835-7594;pass:END;sub:END;*/

Shader "Another Circus/2dLitBillBoard" {
    Properties {
        _MainTex ("MainTex", 2D) = "white" {}
        _Color ("Color", Color) = (1,1,1,1)
        _LightWrapping ("LightWrapping", Range(0, 1)) = 0
        _Transmission ("Transmission", Range(0, 1)) = 0
        _CutAmount ("Cut Amount", Range(0, 1)) = 0
        _AnimTexture ("AnimTexture", 2D) = "white" {}
        _AnimColor ("AnimColor", Color) = (0.5,0.5,0.5,1)
        _WaterTilling ("WaterTilling", Range(0, 1)) = 1
        _WaterSpeed01 ("Water Speed 01", Float ) = 0
        _Refraction ("Refraction", 2D) = "bump" {}
        _RefractAmount ("RefractAmount", Range(0, 1)) = 0.4965132
        _RefractGrandHeight ("RefractGrandHeight", Range(-20, 20)) = 1
        _RefractGrandSmooth ("RefractGrandSmooth", Range(-10, 10)) = 1
        _EmissionTexture ("EmissionTexture", 2D) = "white" {}
        _EmissionAmount ("EmissionAmount", Range(0, 1)) = 0
        [HideInInspector]_Cutoff ("Alpha cutoff", Range(0,1)) = 0.5
    }
    SubShader {
        Tags {
            "IgnoreProjector"="True"
            "Queue"="Transparent"
            "RenderType"="Transparent"
            "CanUseSpriteAtlas"="True"
            "PreviewType"="Plane"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            Cull Off
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma multi_compile_fwdbase
            #pragma multi_compile_fog
            #pragma exclude_renderers d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform float4 _TimeEditor;
            uniform float4 _Color;
            uniform sampler2D _MainTex; uniform float4 _MainTex_ST;
            uniform float _LightWrapping;
            uniform float _Transmission;
            uniform float _CutAmount;
            uniform sampler2D _AnimTexture; uniform float4 _AnimTexture_ST;
            uniform float4 _AnimColor;
            uniform float _WaterTilling;
            uniform float _WaterSpeed01;
            uniform sampler2D _Refraction; uniform float4 _Refraction_ST;
            uniform float _RefractAmount;
            uniform float _RefractGrandHeight;
            uniform float _RefractGrandSmooth;
            uniform sampler2D _EmissionTexture; uniform float4 _EmissionTexture_ST;
            uniform float _EmissionAmount;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
                float3 normalDir : TEXCOORD2;
                UNITY_FOG_COORDS(3)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                return o;
            }
            float4 frag(VertexOutput i, float facing : VFACE) : COLOR {
                float isFrontFace = ( facing >= 0 ? 1 : 0 );
                float faceSign = ( facing >= 0 ? 1 : -1 );
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float3 viewReflectDirection = reflect( -viewDirection, normalDirection );
                float4 _MainTex_var = tex2D(_MainTex,TRANSFORM_TEX(i.uv0, _MainTex));
                float node_295 = (_MainTex_var.a*_Color.a);
                clip((node_295*_CutAmount) - 0.5);
                float3 lightDirection = normalize(_WorldSpaceLightPos0.xyz);
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
                float attenuation = 1;
                float3 attenColor = attenuation * _LightColor0.xyz;
/////// GI Data:
                UnityLight light;
                #ifdef LIGHTMAP_OFF
                    light.color = lightColor;
                    light.dir = lightDirection;
                    light.ndotl = LambertTerm (normalDirection, light.dir);
                #else
                    light.color = half3(0.f, 0.f, 0.f);
                    light.ndotl = 0.0f;
                    light.dir = half3(0.f, 0.f, 0.f);
                #endif
                UnityGIInput d;
                d.light = light;
                d.worldPos = i.posWorld.xyz;
                d.worldViewDir = viewDirection;
                d.atten = attenuation;
                Unity_GlossyEnvironmentData ugls_en_data;
                ugls_en_data.roughness = 1.0 - 0;
                ugls_en_data.reflUVW = viewReflectDirection;
                UnityGI gi = UnityGlobalIllumination(d, 1, normalDirection, ugls_en_data );
                lightDirection = gi.light.dir;
                lightColor = gi.light.color;
/////// Diffuse:
                float NdotL = dot( normalDirection, lightDirection );
                float3 w = float3(_LightWrapping,_LightWrapping,_LightWrapping)*0.5; // Light wrapping
                float3 NdotLWrap = NdotL * ( 1.0 - w );
                float3 forwardLight = max(float3(0.0,0.0,0.0), NdotLWrap + w );
                float3 backLight = max(float3(0.0,0.0,0.0), -NdotLWrap + w ) * float3(_Transmission,_Transmission,_Transmission);
                NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = (forwardLight+backLight) * attenColor;
                float3 indirectDiffuse = float3(0,0,0);
                indirectDiffuse += UNITY_LIGHTMODEL_AMBIENT.rgb; // Ambient Light
                float4 node_1646 = _Time + _TimeEditor;
                float2 node_1939 = (i.posWorld.rgb*_WaterTilling).rg;
                float3 _Refraction_var = UnpackNormal(tex2D(_Refraction,TRANSFORM_TEX(i.uv0, _Refraction)));
                float2 node_8400 = lerp(float2(0,0),_Refraction_var.rgb.rb,_RefractAmount);
                float2 node_4937 = (((node_1939+node_8400)+1.0)+(node_1646.g*_WaterSpeed01)*float2(0,1));
                float4 _AnimTexture_var = tex2D(_AnimTexture,TRANSFORM_TEX(node_4937, _AnimTexture));
                float3 diffuseColor = (saturate((1.0-(1.0-(_MainTex_var.rgb*_Color.rgb))*(1.0-(_AnimColor.rgb*_AnimTexture_var.rgb*saturate((_RefractGrandHeight-(_RefractGrandSmooth*i.posWorld.g)))))))*node_295);
                float3 diffuse = (directDiffuse + indirectDiffuse) * diffuseColor;
////// Emissive:
                float4 _EmissionTexture_var = tex2D(_EmissionTexture,TRANSFORM_TEX(i.uv0, _EmissionTexture));
                float3 emissive = (_EmissionTexture_var.rgb*_EmissionAmount);
/// Final Color:
                float3 finalColor = diffuse + emissive;
                fixed4 finalRGBA = fixed4(finalColor,node_295);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "FORWARD_DELTA"
            Tags {
                "LightMode"="ForwardAdd"
            }
            Blend One One
            Cull Off
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDADD
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma multi_compile_fwdadd
            #pragma multi_compile_fog
            #pragma exclude_renderers d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform float4 _TimeEditor;
            uniform float4 _Color;
            uniform sampler2D _MainTex; uniform float4 _MainTex_ST;
            uniform float _LightWrapping;
            uniform float _Transmission;
            uniform float _CutAmount;
            uniform sampler2D _AnimTexture; uniform float4 _AnimTexture_ST;
            uniform float4 _AnimColor;
            uniform float _WaterTilling;
            uniform float _WaterSpeed01;
            uniform sampler2D _Refraction; uniform float4 _Refraction_ST;
            uniform float _RefractAmount;
            uniform float _RefractGrandHeight;
            uniform float _RefractGrandSmooth;
            uniform sampler2D _EmissionTexture; uniform float4 _EmissionTexture_ST;
            uniform float _EmissionAmount;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
                float3 normalDir : TEXCOORD2;
                LIGHTING_COORDS(3,4)
                UNITY_FOG_COORDS(5)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i, float facing : VFACE) : COLOR {
                float isFrontFace = ( facing >= 0 ? 1 : 0 );
                float faceSign = ( facing >= 0 ? 1 : -1 );
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float4 _MainTex_var = tex2D(_MainTex,TRANSFORM_TEX(i.uv0, _MainTex));
                float node_295 = (_MainTex_var.a*_Color.a);
                clip((node_295*_CutAmount) - 0.5);
                float3 lightDirection = normalize(lerp(_WorldSpaceLightPos0.xyz, _WorldSpaceLightPos0.xyz - i.posWorld.xyz,_WorldSpaceLightPos0.w));
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
/////// Diffuse:
                float NdotL = dot( normalDirection, lightDirection );
                float3 w = float3(_LightWrapping,_LightWrapping,_LightWrapping)*0.5; // Light wrapping
                float3 NdotLWrap = NdotL * ( 1.0 - w );
                float3 forwardLight = max(float3(0.0,0.0,0.0), NdotLWrap + w );
                float3 backLight = max(float3(0.0,0.0,0.0), -NdotLWrap + w ) * float3(_Transmission,_Transmission,_Transmission);
                NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = (forwardLight+backLight) * attenColor;
                float4 node_1646 = _Time + _TimeEditor;
                float2 node_1939 = (i.posWorld.rgb*_WaterTilling).rg;
                float3 _Refraction_var = UnpackNormal(tex2D(_Refraction,TRANSFORM_TEX(i.uv0, _Refraction)));
                float2 node_8400 = lerp(float2(0,0),_Refraction_var.rgb.rb,_RefractAmount);
                float2 node_4937 = (((node_1939+node_8400)+1.0)+(node_1646.g*_WaterSpeed01)*float2(0,1));
                float4 _AnimTexture_var = tex2D(_AnimTexture,TRANSFORM_TEX(node_4937, _AnimTexture));
                float3 diffuseColor = (saturate((1.0-(1.0-(_MainTex_var.rgb*_Color.rgb))*(1.0-(_AnimColor.rgb*_AnimTexture_var.rgb*saturate((_RefractGrandHeight-(_RefractGrandSmooth*i.posWorld.g)))))))*node_295);
                float3 diffuse = directDiffuse * diffuseColor;
/// Final Color:
                float3 finalColor = diffuse;
                fixed4 finalRGBA = fixed4(finalColor * node_295,0);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "ShadowCaster"
            Tags {
                "LightMode"="ShadowCaster"
            }
            Offset 1, 1
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_SHADOWCASTER
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "Lighting.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma fragmentoption ARB_precision_hint_fastest
            #pragma multi_compile_shadowcaster
            #pragma multi_compile_fog
            #pragma exclude_renderers d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform float4 _Color;
            uniform sampler2D _MainTex; uniform float4 _MainTex_ST;
            uniform float _CutAmount;
            struct VertexInput {
                float4 vertex : POSITION;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                V2F_SHADOW_CASTER;
                float2 uv0 : TEXCOORD1;
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                TRANSFER_SHADOW_CASTER(o)
                return o;
            }
            float4 frag(VertexOutput i, float facing : VFACE) : COLOR {
                float isFrontFace = ( facing >= 0 ? 1 : 0 );
                float faceSign = ( facing >= 0 ? 1 : -1 );
                float4 _MainTex_var = tex2D(_MainTex,TRANSFORM_TEX(i.uv0, _MainTex));
                float node_295 = (_MainTex_var.a*_Color.a);
                clip((node_295*_CutAmount) - 0.5);
                SHADOW_CASTER_FRAGMENT(i)
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
    CustomEditor "ShaderForgeMaterialInspector"
}
